/* The RCS version of hdfgen.pl used to create this file is: */
/* $Id: hdfgen.pl,v 1.5 2000/02/17 18:32:30 esm Exp  */

  /* An RCS (Revision Control System) header */

  /* for the include file is not on the first line. */

#include "con_hk.h"
#include "df.h"

int32 vgrp_id_con_hk;
static int32 vdata_id_con_hk;

  /* 4889 is the size of con_hk.h + 1 added line */
char Vgrp_descrp_Concentrator_Housekeeping[4889];

/****----  init create function  ----****/

int32 init_cr_con_hk(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{
  int32 retval=0;
  int32 vgrp_ref_w;
  int32 ann_id_w;
  int32 wr_Vgrp_desc_con_hk();

  void print_con_hk_error();

  /*         Setup a Vgroup         */
  if ((vgrp_id_con_hk = Vattach(hdf_fp, -1, "w"))==FAIL) {
    print_con_hk_error("init_cr_con_hk -> Vattach: Couldn't create Vgroup");
    retval = -1;
  }
  Vsetname(vgrp_id_con_hk, "VG_Concentrator_Housekeeping"); 
  Vsetclass(vgrp_id_con_hk, "VG_CON_HK");


  /*      Get the Vgroup reference     */
  if ((vgrp_ref_w = Vfind(hdf_fp, "VG_Concentrator_Housekeeping" )) ==FAIL) {
    print_con_hk_error("init_cr_con_hk -> Vfind: Couldn't get Vgrp reference");
    retval = -1;
  }
  /*      Add a description to the Vgroup      */
  wr_Vgrp_desc_con_hk(Vgrp_descrp_Concentrator_Housekeeping);

  if ((ann_id_w = ANcreate(an_id, DFTAG_VG, vgrp_ref_w, AN_DATA_DESC)) ==FAIL) {
    print_con_hk_error("init_cr_con_hk -> ANcreate: Can't create Vgrp description");
    retval = -1;
  }
  if ((ANwriteann(ann_id_w, Vgrp_descrp_Concentrator_Housekeeping, sizeof(Vgrp_descrp_Concentrator_Housekeeping))) ==FAIL) {
    print_con_hk_error("init_cr_con_hk -> ANwriteann: Can't write Vgrp description");
    retval = -1;
  }
  ANendaccess(ann_id_w);

  /*        Setup a Vdata        */
  if ((vdata_id_con_hk = VSattach(hdf_fp, -1, "w")) ==FAIL) {
    print_con_hk_error("init_cr_con_hk -> VSattach: Couldn't attach to Vdata");
    retval = -1;
  }
  VSsetname(vdata_id_con_hk, "Concentrator_Housekeeping");
  VSsetclass(vdata_id_con_hk, classname);

  /*       Insert the Vdata into the Vgroup       */
  if ((Vinsert(vgrp_id_con_hk, vdata_id_con_hk)) ==FAIL) {
    print_con_hk_error("init_cr_con_hk -> Vinsert: Couldn't insert Vdata into Vgroup");
    retval = -1;
  }

  /*    Define the fields in the Vdata    */
  if (VSfdefine(vdata_id_con_hk, "sclk_seconds", DFNT_UINT32, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define sclk_seconds");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "sclk_subseconds", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define sclk_subseconds");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "APID_status", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define APID_status");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "elec_req", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define elec_req");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "accel_req", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define accel_req");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "rej_req", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define rej_req");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "elec_level", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define elec_level");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "accel_level", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define accel_level");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "rej_level", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define rej_level");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "elec_set", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define elec_set");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "accel_set", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define accel_set");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "rej_set", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define rej_set");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "MON_5V", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define MON_5V");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "MON_12V", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define MON_12V");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "elec_fault_count", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define elec_fault_count");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "accel_fault_count", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define accel_fault_count");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "rej_fault_count", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define rej_fault_count");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "elec_maximum", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define elec_maximum");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "elec_minimum", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define elec_minimum");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "accel_maximum", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define accel_maximum");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "accel_minimum", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define accel_minimum");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "rej_maximum", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define rej_maximum");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "rej_minimum", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define rej_minimum");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "SW_status", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define SW_status");
    retval = -1;
  }
  if (VSfdefine(vdata_id_con_hk, "CMD_status", DFNT_UINT16, (1) )) {
    print_con_hk_error("init_cr_con_hk -> VSfdefine: Couldn't define CMD_status");
    retval = -1;
  }

  if (VSsetfields(vdata_id_con_hk,"sclk_seconds, sclk_subseconds, APID_status, elec_req, accel_req, rej_req, elec_level, accel_level, rej_level, elec_set, accel_set, rej_set, MON_5V, MON_12V, elec_fault_count, accel_fault_count, rej_fault_count, elec_maximum, elec_minimum, accel_maximum, accel_minimum, rej_maximum, rej_minimum, SW_status, CMD_status")){
    print_con_hk_error("init_cr_con_hk -> VSsetfields: Couldn't set fields");
    retval = -1;
  }

  return(retval);
}

/* Included for backwards compatibility */

int32 init_wr_con_hk(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{ return( init_cr_con_hk(hdf_fp, sd_id, an_id, classname) ); }

/******---- write function ----******/

int32 write_con_hk(struct Concentrator_Housekeeping Concentrator_Housekeeping_struc, int32 recnum)
{
  int32 retval = 0;
  uint8 *odata;

void print_con_hk_error();
void pack_con_hk();

  odata = (uint8 *) malloc(sizeof(struct Concentrator_Housekeeping));
  pack_con_hk(odata, &Concentrator_Housekeeping_struc);

  if(recnum!=-1) {
	if(VSseek(vdata_id_con_hk, recnum)==-1) {
		print_con_hk_error("write_con_hk -> VSseek: error.");
		retval = -1;
	}
  }
  if(VSwrite(vdata_id_con_hk, (uint8 *)odata, 1, FULL_INTERLACE) == -1)
    print_con_hk_error("write_con_hk -> VSwrite: Couldn't write data.");

  memset(&Concentrator_Housekeeping_struc, 0, sizeof(struct Concentrator_Housekeeping));
  free(odata);
  return(retval);
}

/*----   close write function    ----*/

void close_wr_con_hk()
{
  VSdetach(vdata_id_con_hk);
  Vdetach(vgrp_id_con_hk);
}

/*----     init access function    ----*/

int32 init_acc_con_hk(int32 hdf_fp, int32 sd_id, char *access_mode)
{
  int32 vdata_ref;
  int32 num_rec;

  void print_con_hk_error();


  if ((vdata_ref = VSfind(hdf_fp, "Concentrator_Housekeeping")) <= 0 ) {
    print_con_hk_error("init_acc_con_hk -> VSfind: Found no vdata of specified type.");
    return(0);
  }
  if ((vdata_id_con_hk = VSattach(hdf_fp, vdata_ref, access_mode)) ==FAIL) {
    print_con_hk_error("init_acc_con_hk -> VSattach: Couldn't attach to hdf file.");
    return(-1);
  }

  VSinquire(vdata_id_con_hk, &num_rec, NULL, NULL, NULL, NULL);
  if (num_rec == 0) { return(0); }


  if (VSsetfields(vdata_id_con_hk,"sclk_seconds, sclk_subseconds, APID_status, elec_req, accel_req, rej_req, elec_level, accel_level, rej_level, elec_set, accel_set, rej_set, MON_5V, MON_12V, elec_fault_count, accel_fault_count, rej_fault_count, elec_maximum, elec_minimum, accel_maximum, accel_minimum, rej_maximum, rej_minimum, SW_status, CMD_status")) {
      print_con_hk_error("init_acc_con_hk -> VSsetfields: Unable to set fields.");

      return(-1);
  }
  return(num_rec);
}

/* Included for backwards compatability */

int32 init_rd_con_hk(int32 hdf_fp, int32 sd_id, char *access_mode)
{ return ( init_acc_con_hk(hdf_fp, sd_id, access_mode) ); }

/******---- read function ----******/

int32 read_con_hk(struct Concentrator_Housekeeping *Concentrator_Housekeeping_struc, int32 recnum_rd)
{
static int32 last_recnum = -1;
int32 maxrec;
int32 retval = 0;
uint8 *odata;

void print_con_hk_error();
void unpack_con_hk();

  if(recnum_rd==-1) recnum_rd=last_recnum+1;

  odata = (uint8 *) malloc(sizeof(struct Concentrator_Housekeeping));
  VSinquire(vdata_id_con_hk, &maxrec, NULL, NULL, NULL, NULL);
  if (recnum_rd >= maxrec) return(-1);
  if (recnum_rd != last_recnum+1)
      if (VSseek(vdata_id_con_hk, recnum_rd)==FAIL) {
          print_con_hk_error("read_con_hk -> VSseek unsuccessful");
          retval = -1;
    }
  last_recnum = recnum_rd;

  if(VSread(vdata_id_con_hk, (uint8 *)odata, 1, FULL_INTERLACE) ==FAIL) {
    print_con_hk_error("read_con_hk -> VSread: Couldn't read data.");
    retval = -1;
  }
  unpack_con_hk(odata, Concentrator_Housekeeping_struc);
  free(odata);
  return(retval);
}

/*----   close read function    ----*/

void close_rd_con_hk()
{
  VSdetach(vdata_id_con_hk);
}

/*----  Read V group description, function    ----*/
void rd_Vgrp_desc_con_hk(int32 hdf_fp, int32 an_id)
{
  int32 ann_id_r;
  int32 num_ann;
  int32 *ann_list;
  int32 vgrp_ref_r;

void print_con_hk_error();

  /*      Get the Vgroup reference     */
  if ((vgrp_ref_r = Vfind(hdf_fp, "VG_Concentrator_Housekeeping" )) ==FAIL)
    print_con_hk_error("rd_Vgrp_con_hk -> Vfind: Couldn't get Vgrp reference.");

  if ((num_ann = ANnumann(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r)) ==FAIL)
    print_con_hk_error("rd_Vgrp_con_hk -> ANnumann: Couldn't get number of annotations.");

printf("1numann= %d \n", num_ann);
    ann_list = HDmalloc(num_ann * sizeof(int32));
printf("1ann_list= %d \n", ann_list);
  if ((num_ann = ANannlist(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r, ann_list)) ==FAIL)
    print_con_hk_error("rd_Vgrp_con_hk -> ANannlist: Couldn't");

printf("2numann= %d \n", num_ann);
printf("2ann_list= %d \n", ann_list);
  if ((ann_id_r = ANselect(an_id, (num_ann-1), AN_DATA_DESC)) ==FAIL)
    print_con_hk_error("rd_Vgrp_con_hk -> ANselect: Couldn't");

  if (ANreadann(ann_id_r, Vgrp_descrp_Concentrator_Housekeeping, HDstrlen(Vgrp_descrp_Concentrator_Housekeeping)) ==FAIL)
    print_con_hk_error("rd_Vgrp_con_hk -> ANreadann: Couldn't");

  printf("AN: %s\n", Vgrp_descrp_Concentrator_Housekeeping);
  ANendaccess(ann_id_r);
  ANend(an_id);
}

/*----   error function    ----*/

void print_con_hk_error(int8 *mess)
{
  fprintf(stderr,"\nERROR in  con_hk.c -> %s\n", mess);
  HEprint(stderr, 0);
}

/*----   pack function    ----*/

void pack_con_hk(uint8 *data, struct Concentrator_Housekeeping *Concentrator_Housekeeping_ptr)
{
int32 ptr=0;

   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->sclk_seconds, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->sclk_subseconds, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->APID_status, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->elec_req, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->accel_req, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->rej_req, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->elec_level, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->accel_level, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->rej_level, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->elec_set, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->accel_set, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->rej_set, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->MON_5V, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->MON_12V, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->elec_fault_count, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->accel_fault_count, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->rej_fault_count, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->elec_maximum, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->elec_minimum, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->accel_maximum, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->accel_minimum, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->rej_maximum, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->rej_minimum, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->SW_status, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &Concentrator_Housekeeping_ptr->CMD_status, ((2)*(1)) );
   ptr+= ((2)*(1));
}

/*----   unpack function    ----*/

void unpack_con_hk(uint8 *data, struct Concentrator_Housekeeping *Concentrator_Housekeeping_ptr)
{
int32 ptr=0;

   memcpy(&Concentrator_Housekeeping_ptr->sclk_seconds, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->sclk_subseconds, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->APID_status, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->elec_req, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->accel_req, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->rej_req, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->elec_level, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->accel_level, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->rej_level, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->elec_set, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->accel_set, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->rej_set, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->MON_5V, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->MON_12V, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->elec_fault_count, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->accel_fault_count, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->rej_fault_count, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->elec_maximum, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->elec_minimum, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->accel_maximum, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->accel_minimum, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->rej_maximum, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->rej_minimum, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->SW_status, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&Concentrator_Housekeeping_ptr->CMD_status, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
}
int32 get_vgrp_id_con_hk() {return(vgrp_id_con_hk);}

/*----   V group description function    ----*/

int32 wr_Vgrp_desc_con_hk(char *wr_strval)
{
  strcpy(wr_strval, "The file 'con_hk.h' is shown below, it was used to create the data in the Vgroup named 'VG_Concentrator_Housekeeping'.\n\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"/*\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   GNS EDR Structure definitions -- Concentrator Housekeeping Data \n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   BVS/NAIF, June 7, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"      Changed sclk_subseconds type from uint8 to uint16 to preserve \n");
  strcat(wr_strval,"      full resolution of the fractional part of SCLK. Updated \n");
  strcat(wr_strval,"      description to reflect this change. Added APID_status, SW_status\n");
  strcat(wr_strval,"      and CMD_status bit breakdown description.\n");
  strcat(wr_strval,"        \n");
  strcat(wr_strval,"   BVS/NAIF, March 2, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"      Reformatted comments; included gnd_edr_const.h.\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   BVS/NAIF, February 17, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"*/\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"#include \"hdfi.h\"\n");
  strcat(wr_strval,"#include \"gns_edr_const.h\"\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"/*\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"   Concentrator Housekeeping data structure -- APID # 25\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"      sclk_seconds      -- SCLK seconds \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      sclk_subseconds   -- fractions (1/65536th) of SCLK second \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      APID_status       -- APID status word (? bit order):\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"                              bit 0 = Checksum_Error_Occ_Indication\n");
  strcat(wr_strval,"                              bit 1 = Sample_Mode\n");
  strcat(wr_strval,"                              bits 2-3 = COLLECTION_TYPE\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      elec_req          -- from last config command sent\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      accel_req         -- from last config command sent\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      rej_req           -- from last config command sent\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      elec_level        -- ADC value from electrode voltage readback, \n");
  strcat(wr_strval,"                           (0-4095d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      accel_level       -- ADC value from acceleration voltage readback,\n");
  strcat(wr_strval,"                           (0-4095d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      rej_level         -- ADC value from rejection voltage readback, \n");
  strcat(wr_strval,"                           (0-4095d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      elec_set          -- ADC value from electrode voltage DAC \n");
  strcat(wr_strval,"                           readback, (0-4095d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      accel_set         -- ADC value from acceleration voltage DAC \n");
  strcat(wr_strval,"                           readback, (0-4095d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      rej_set           -- ADC value from rejection voltage DAC \n");
  strcat(wr_strval,"                           readback, (0-4095d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      MON_5V            -- ADC value from 5 volt monitor, (0-4095d)                        \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      MON_12V           -- ADC value from 12 volt monitor, (0-4095d)                        \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      elec_fault_count  -- count of electrode voltage errors since \n");
  strcat(wr_strval,"                           last report, (0-65535d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      accel_fault_count -- count of acceleration voltage errors since \n");
  strcat(wr_strval,"                           last report, (0-65535d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      rej_fault_count   -- count of rejection voltage errors since \n");
  strcat(wr_strval,"                           last report, (0-65535d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      elec_maximum      -- maximum electrode voltage readback value \n");
  strcat(wr_strval,"                           since last report, (0-4095d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      elec_minimum      -- minimum electrode voltage readback value \n");
  strcat(wr_strval,"                           since last report, (0-4095d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      accel_maximum     -- maximum acceleration voltage readback value \n");
  strcat(wr_strval,"                           since last report, (0-4095d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      accel_minimum     -- minimum acceleration voltage readback value \n");
  strcat(wr_strval,"                           since last report, (0-4095d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      rej_maximum       -- maximum rejection voltage readback value \n");
  strcat(wr_strval,"                           since last report, (0-4095d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      rej_minimum       -- minimum rejection voltage readback value \n");
  strcat(wr_strval,"                           since last report, (0-4095d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      SW_status         -- Concentrator SW status word (? bit order):              \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"                              bit 0 = HV_ENABLE\n");
  strcat(wr_strval,"                              bit 1 = HV_ENABLE_LIMIT\n");
  strcat(wr_strval,"                              bit 2 = RAM_TEST\n");
  strcat(wr_strval,"                              bit 3 = ROM_TEST\n");
  strcat(wr_strval,"                              bit 4 = INTERUPT_TEST\n");
  strcat(wr_strval,"                              bit 5 = TIMING_TEST\n");
  strcat(wr_strval,"                              bit 6 = DAC1_TEST\n");
  strcat(wr_strval,"                              bit 7 = DAC2_TEST\n");
  strcat(wr_strval,"                              bit 8 = DAC3_TEST\n");
  strcat(wr_strval,"                              bit 9 = PROCESSOR_RESET\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      CMD_status        -- Concentrator CMD status word (? bit order):\n");
  strcat(wr_strval,"                    \n");
  strcat(wr_strval,"                              bits 0-7 = Command_Status_Counter\n");
  strcat(wr_strval,"                              bit 8 = CMD_Status_Bad_Command_Flag\n");
  strcat(wr_strval,"                              bit 9 = CMD_Status_Bad_Parameter_Flag\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"*/\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"struct Concentrator_Housekeeping {\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"   uint32   sclk_seconds;\n");
  strcat(wr_strval,"   uint16   sclk_subseconds;\n");
  strcat(wr_strval,"   uint16   APID_status;\n");
  strcat(wr_strval,"   uint16   elec_req;\n");
  strcat(wr_strval,"   uint16   accel_req;\n");
  strcat(wr_strval,"   uint16   rej_req;\n");
  strcat(wr_strval,"   uint16   elec_level;\n");
  strcat(wr_strval,"   uint16   accel_level;\n");
  strcat(wr_strval,"   uint16   rej_level;\n");
  strcat(wr_strval,"   uint16   elec_set;\n");
  strcat(wr_strval,"   uint16   accel_set;\n");
  strcat(wr_strval,"   uint16   rej_set;\n");
  strcat(wr_strval,"   uint16   MON_5V;\n");
  strcat(wr_strval,"   uint16   MON_12V;\n");
  strcat(wr_strval,"   uint16   elec_fault_count;\n");
  strcat(wr_strval,"   uint16   accel_fault_count;\n");
  strcat(wr_strval,"   uint16   rej_fault_count;\n");
  strcat(wr_strval,"   uint16   elec_maximum;\n");
  strcat(wr_strval,"   uint16   elec_minimum;\n");
  strcat(wr_strval,"   uint16   accel_maximum;\n");
  strcat(wr_strval,"   uint16   accel_minimum;\n");
  strcat(wr_strval,"   uint16   rej_maximum;\n");
  strcat(wr_strval,"   uint16   rej_minimum;\n");
  strcat(wr_strval,"   uint16   SW_status;\n");
  strcat(wr_strval,"   uint16   CMD_status;\n");
  strcat(wr_strval,"                                       \n");
  strcat(wr_strval,"};\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"\n");
  return(0);
}
