/* The RCS version of hdfgen.pl used to create this file is: */
/* $Id: hdfgen.pl,v 1.5 2000/02/17 18:32:30 esm Exp  */

  /* An RCS (Revision Control System) header */

  /* for the include file is not on the first line. */

#include "gem_hk.h"
#include "df.h"

int32 vgrp_id_gem_hk;
static int32 vdata_id_gem_hk;

  /* 4260 is the size of gem_hk.h + 1 added line */
char Vgrp_descrp_GEM_Housekeeping[4260];

/****----  init create function  ----****/

int32 init_cr_gem_hk(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{
  int32 retval=0;
  int32 vgrp_ref_w;
  int32 ann_id_w;
  int32 wr_Vgrp_desc_gem_hk();

  void print_gem_hk_error();

  /*         Setup a Vgroup         */
  if ((vgrp_id_gem_hk = Vattach(hdf_fp, -1, "w"))==FAIL) {
    print_gem_hk_error("init_cr_gem_hk -> Vattach: Couldn't create Vgroup");
    retval = -1;
  }
  Vsetname(vgrp_id_gem_hk, "VG_GEM_Housekeeping"); 
  Vsetclass(vgrp_id_gem_hk, "VG_GEM_HK");


  /*      Get the Vgroup reference     */
  if ((vgrp_ref_w = Vfind(hdf_fp, "VG_GEM_Housekeeping" )) ==FAIL) {
    print_gem_hk_error("init_cr_gem_hk -> Vfind: Couldn't get Vgrp reference");
    retval = -1;
  }
  /*      Add a description to the Vgroup      */
  wr_Vgrp_desc_gem_hk(Vgrp_descrp_GEM_Housekeeping);

  if ((ann_id_w = ANcreate(an_id, DFTAG_VG, vgrp_ref_w, AN_DATA_DESC)) ==FAIL) {
    print_gem_hk_error("init_cr_gem_hk -> ANcreate: Can't create Vgrp description");
    retval = -1;
  }
  if ((ANwriteann(ann_id_w, Vgrp_descrp_GEM_Housekeeping, sizeof(Vgrp_descrp_GEM_Housekeeping))) ==FAIL) {
    print_gem_hk_error("init_cr_gem_hk -> ANwriteann: Can't write Vgrp description");
    retval = -1;
  }
  ANendaccess(ann_id_w);

  /*        Setup a Vdata        */
  if ((vdata_id_gem_hk = VSattach(hdf_fp, -1, "w")) ==FAIL) {
    print_gem_hk_error("init_cr_gem_hk -> VSattach: Couldn't attach to Vdata");
    retval = -1;
  }
  VSsetname(vdata_id_gem_hk, "GEM_Housekeeping");
  VSsetclass(vdata_id_gem_hk, classname);

  /*       Insert the Vdata into the Vgroup       */
  if ((Vinsert(vgrp_id_gem_hk, vdata_id_gem_hk)) ==FAIL) {
    print_gem_hk_error("init_cr_gem_hk -> Vinsert: Couldn't insert Vdata into Vgroup");
    retval = -1;
  }

  /*    Define the fields in the Vdata    */
  if (VSfdefine(vdata_id_gem_hk, "sclk_seconds", DFNT_UINT32, (1) )) {
    print_gem_hk_error("init_cr_gem_hk -> VSfdefine: Couldn't define sclk_seconds");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_hk, "sclk_subseconds", DFNT_UINT16, (1) )) {
    print_gem_hk_error("init_cr_gem_hk -> VSfdefine: Couldn't define sclk_subseconds");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_hk, "APID_status", DFNT_UINT16, (1) )) {
    print_gem_hk_error("init_cr_gem_hk -> VSfdefine: Couldn't define APID_status");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_hk, "start_level", DFNT_UINT16, (1) )) {
    print_gem_hk_error("init_cr_gem_hk -> VSfdefine: Couldn't define start_level");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_hk, "step_size", DFNT_UINT16, (1) )) {
    print_gem_hk_error("init_cr_gem_hk -> VSfdefine: Couldn't define step_size");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_hk, "set", DFNT_UINT16, (GEM_SPIN_LEVELS) )) {
    print_gem_hk_error("init_cr_gem_hk -> VSfdefine: Couldn't define set");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_hk, "level", DFNT_UINT16, (GEM_SPIN_LEVELS) )) {
    print_gem_hk_error("init_cr_gem_hk -> VSfdefine: Couldn't define level");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_hk, "CEM_set", DFNT_UINT16, (1) )) {
    print_gem_hk_error("init_cr_gem_hk -> VSfdefine: Couldn't define CEM_set");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_hk, "CEM_level", DFNT_UINT16, (1) )) {
    print_gem_hk_error("init_cr_gem_hk -> VSfdefine: Couldn't define CEM_level");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_hk, "AMP_set", DFNT_UINT16, (1) )) {
    print_gem_hk_error("init_cr_gem_hk -> VSfdefine: Couldn't define AMP_set");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_hk, "MON_5V", DFNT_UINT16, (1) )) {
    print_gem_hk_error("init_cr_gem_hk -> VSfdefine: Couldn't define MON_5V");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_hk, "MON_12V", DFNT_UINT16, (1) )) {
    print_gem_hk_error("init_cr_gem_hk -> VSfdefine: Couldn't define MON_12V");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_hk, "SW_status", DFNT_UINT16, (1) )) {
    print_gem_hk_error("init_cr_gem_hk -> VSfdefine: Couldn't define SW_status");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_hk, "CMD_status", DFNT_UINT16, (1) )) {
    print_gem_hk_error("init_cr_gem_hk -> VSfdefine: Couldn't define CMD_status");
    retval = -1;
  }

  if (VSsetfields(vdata_id_gem_hk,"sclk_seconds, sclk_subseconds, APID_status, start_level, step_size, set, level, CEM_set, CEM_level, AMP_set, MON_5V, MON_12V, SW_status, CMD_status")){
    print_gem_hk_error("init_cr_gem_hk -> VSsetfields: Couldn't set fields");
    retval = -1;
  }

  return(retval);
}

/* Included for backwards compatibility */

int32 init_wr_gem_hk(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{ return( init_cr_gem_hk(hdf_fp, sd_id, an_id, classname) ); }

/******---- write function ----******/

int32 write_gem_hk(struct GEM_Housekeeping GEM_Housekeeping_struc, int32 recnum)
{
  int32 retval = 0;
  uint8 *odata;

void print_gem_hk_error();
void pack_gem_hk();

  odata = (uint8 *) malloc(sizeof(struct GEM_Housekeeping));
  pack_gem_hk(odata, &GEM_Housekeeping_struc);

  if(recnum!=-1) {
	if(VSseek(vdata_id_gem_hk, recnum)==-1) {
		print_gem_hk_error("write_gem_hk -> VSseek: error.");
		retval = -1;
	}
  }
  if(VSwrite(vdata_id_gem_hk, (uint8 *)odata, 1, FULL_INTERLACE) == -1)
    print_gem_hk_error("write_gem_hk -> VSwrite: Couldn't write data.");

  memset(&GEM_Housekeeping_struc, 0, sizeof(struct GEM_Housekeeping));
  free(odata);
  return(retval);
}

/*----   close write function    ----*/

void close_wr_gem_hk()
{
  VSdetach(vdata_id_gem_hk);
  Vdetach(vgrp_id_gem_hk);
}

/*----     init access function    ----*/

int32 init_acc_gem_hk(int32 hdf_fp, int32 sd_id, char *access_mode)
{
  int32 vdata_ref;
  int32 num_rec;

  void print_gem_hk_error();


  if ((vdata_ref = VSfind(hdf_fp, "GEM_Housekeeping")) <= 0 ) {
    print_gem_hk_error("init_acc_gem_hk -> VSfind: Found no vdata of specified type.");
    return(0);
  }
  if ((vdata_id_gem_hk = VSattach(hdf_fp, vdata_ref, access_mode)) ==FAIL) {
    print_gem_hk_error("init_acc_gem_hk -> VSattach: Couldn't attach to hdf file.");
    return(-1);
  }

  VSinquire(vdata_id_gem_hk, &num_rec, NULL, NULL, NULL, NULL);
  if (num_rec == 0) { return(0); }


  if (VSsetfields(vdata_id_gem_hk,"sclk_seconds, sclk_subseconds, APID_status, start_level, step_size, set, level, CEM_set, CEM_level, AMP_set, MON_5V, MON_12V, SW_status, CMD_status")) {
      print_gem_hk_error("init_acc_gem_hk -> VSsetfields: Unable to set fields.");

      return(-1);
  }
  return(num_rec);
}

/* Included for backwards compatability */

int32 init_rd_gem_hk(int32 hdf_fp, int32 sd_id, char *access_mode)
{ return ( init_acc_gem_hk(hdf_fp, sd_id, access_mode) ); }

/******---- read function ----******/

int32 read_gem_hk(struct GEM_Housekeeping *GEM_Housekeeping_struc, int32 recnum_rd)
{
static int32 last_recnum = -1;
int32 maxrec;
int32 retval = 0;
uint8 *odata;

void print_gem_hk_error();
void unpack_gem_hk();

  if(recnum_rd==-1) recnum_rd=last_recnum+1;

  odata = (uint8 *) malloc(sizeof(struct GEM_Housekeeping));
  VSinquire(vdata_id_gem_hk, &maxrec, NULL, NULL, NULL, NULL);
  if (recnum_rd >= maxrec) return(-1);
  if (recnum_rd != last_recnum+1)
      if (VSseek(vdata_id_gem_hk, recnum_rd)==FAIL) {
          print_gem_hk_error("read_gem_hk -> VSseek unsuccessful");
          retval = -1;
    }
  last_recnum = recnum_rd;

  if(VSread(vdata_id_gem_hk, (uint8 *)odata, 1, FULL_INTERLACE) ==FAIL) {
    print_gem_hk_error("read_gem_hk -> VSread: Couldn't read data.");
    retval = -1;
  }
  unpack_gem_hk(odata, GEM_Housekeeping_struc);
  free(odata);
  return(retval);
}

/*----   close read function    ----*/

void close_rd_gem_hk()
{
  VSdetach(vdata_id_gem_hk);
}

/*----  Read V group description, function    ----*/
void rd_Vgrp_desc_gem_hk(int32 hdf_fp, int32 an_id)
{
  int32 ann_id_r;
  int32 num_ann;
  int32 *ann_list;
  int32 vgrp_ref_r;

void print_gem_hk_error();

  /*      Get the Vgroup reference     */
  if ((vgrp_ref_r = Vfind(hdf_fp, "VG_GEM_Housekeeping" )) ==FAIL)
    print_gem_hk_error("rd_Vgrp_gem_hk -> Vfind: Couldn't get Vgrp reference.");

  if ((num_ann = ANnumann(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r)) ==FAIL)
    print_gem_hk_error("rd_Vgrp_gem_hk -> ANnumann: Couldn't get number of annotations.");

printf("1numann= %d \n", num_ann);
    ann_list = HDmalloc(num_ann * sizeof(int32));
printf("1ann_list= %d \n", ann_list);
  if ((num_ann = ANannlist(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r, ann_list)) ==FAIL)
    print_gem_hk_error("rd_Vgrp_gem_hk -> ANannlist: Couldn't");

printf("2numann= %d \n", num_ann);
printf("2ann_list= %d \n", ann_list);
  if ((ann_id_r = ANselect(an_id, (num_ann-1), AN_DATA_DESC)) ==FAIL)
    print_gem_hk_error("rd_Vgrp_gem_hk -> ANselect: Couldn't");

  if (ANreadann(ann_id_r, Vgrp_descrp_GEM_Housekeeping, HDstrlen(Vgrp_descrp_GEM_Housekeeping)) ==FAIL)
    print_gem_hk_error("rd_Vgrp_gem_hk -> ANreadann: Couldn't");

  printf("AN: %s\n", Vgrp_descrp_GEM_Housekeeping);
  ANendaccess(ann_id_r);
  ANend(an_id);
}

/*----   error function    ----*/

void print_gem_hk_error(int8 *mess)
{
  fprintf(stderr,"\nERROR in  gem_hk.c -> %s\n", mess);
  HEprint(stderr, 0);
}

/*----   pack function    ----*/

void pack_gem_hk(uint8 *data, struct GEM_Housekeeping *GEM_Housekeeping_ptr)
{
int32 ptr=0;

   memcpy(data+ptr, &GEM_Housekeeping_ptr->sclk_seconds, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &GEM_Housekeeping_ptr->sclk_subseconds, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_Housekeeping_ptr->APID_status, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_Housekeeping_ptr->start_level, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_Housekeeping_ptr->step_size, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_Housekeeping_ptr->set[0], ((2)*(GEM_SPIN_LEVELS)) );
   ptr+= ((2)*(GEM_SPIN_LEVELS));
   memcpy(data+ptr, &GEM_Housekeeping_ptr->level[0], ((2)*(GEM_SPIN_LEVELS)) );
   ptr+= ((2)*(GEM_SPIN_LEVELS));
   memcpy(data+ptr, &GEM_Housekeeping_ptr->CEM_set, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_Housekeeping_ptr->CEM_level, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_Housekeeping_ptr->AMP_set, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_Housekeeping_ptr->MON_5V, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_Housekeeping_ptr->MON_12V, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_Housekeeping_ptr->SW_status, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_Housekeeping_ptr->CMD_status, ((2)*(1)) );
   ptr+= ((2)*(1));
}

/*----   unpack function    ----*/

void unpack_gem_hk(uint8 *data, struct GEM_Housekeeping *GEM_Housekeeping_ptr)
{
int32 ptr=0;

   memcpy(&GEM_Housekeeping_ptr->sclk_seconds, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&GEM_Housekeeping_ptr->sclk_subseconds, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_Housekeeping_ptr->APID_status, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_Housekeeping_ptr->start_level, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_Housekeeping_ptr->step_size, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_Housekeeping_ptr->set[0], data+ptr,  ((2)*(GEM_SPIN_LEVELS)) );
   ptr+= ((2)*(GEM_SPIN_LEVELS));
   memcpy(&GEM_Housekeeping_ptr->level[0], data+ptr,  ((2)*(GEM_SPIN_LEVELS)) );
   ptr+= ((2)*(GEM_SPIN_LEVELS));
   memcpy(&GEM_Housekeeping_ptr->CEM_set, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_Housekeeping_ptr->CEM_level, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_Housekeeping_ptr->AMP_set, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_Housekeeping_ptr->MON_5V, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_Housekeeping_ptr->MON_12V, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_Housekeeping_ptr->SW_status, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_Housekeeping_ptr->CMD_status, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
}
int32 get_vgrp_id_gem_hk() {return(vgrp_id_gem_hk);}

/*----   V group description function    ----*/

int32 wr_Vgrp_desc_gem_hk(char *wr_strval)
{
  strcpy(wr_strval, "The file 'gem_hk.h' is shown below, it was used to create the data in the Vgroup named 'VG_GEM_Housekeeping'.\n\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"/*\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   GNS EDR Structure definitions -- GEM Housekeeping Data \n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   BVS/NAIF, August 23, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"      Per information provided by Eric Dors on 08/21/00 added \n");
  strcat(wr_strval,"      description of bits 10-15 of CMD_status.\n");
  strcat(wr_strval,"        \n");
  strcat(wr_strval,"   BVS/NAIF, June 7, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"      Changed sclk_subseconds type from uint8 to uint16 to preserve \n");
  strcat(wr_strval,"      full resolution of the fractional part of SCLK. Updated \n");
  strcat(wr_strval,"      description to reflect this change. Added APID_status, SW_status\n");
  strcat(wr_strval,"      and CMD_status bit breakdown description.\n");
  strcat(wr_strval,"        \n");
  strcat(wr_strval,"   BVS/NAIF, March 2, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"      Reformatted comments; moved dimension constants to \n");
  strcat(wr_strval,"      gnd_edr_const.h; included gnd_edr_const.h.\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   BVS/NAIF, February 17, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"*/\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"#include \"hdfi.h\"\n");
  strcat(wr_strval,"#include \"gns_edr_const.h\"\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"/*\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"   GEM Housekeeping data structure -- APID # 32\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"      sclk_seconds      -- SCLK seconds \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      sclk_subseconds   -- fractions (1/65536th) of SCLK second \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      APID_status       -- APID status word (? bit order):\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"                              Bits 0-7 = Azimuth_Sampled_Indication\n");
  strcat(wr_strval,"                              Bits 8-9 = Sample_Mode\n");
  strcat(wr_strval,"                              Bit 10 = Checksum_Error_Occur_Indication\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      start_level       -- voltage requested start level that was \n");
  strcat(wr_strval,"                           specified in acquire or manual command, \n");
  strcat(wr_strval,"                           DAC units (0-4095d) \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      step_size         -- voltage level step size that was specified \n");
  strcat(wr_strval,"                           in command, units of 0.01 percent, 0 if \n");
  strcat(wr_strval,"                           manual acqusition                                     \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      set[5]            -- ADC values from ESA voltage DAC readback \n");
  strcat(wr_strval,"                           for the voltage levels 0-4, DAC units \n");
  strcat(wr_strval,"                           (0-4095d)              \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      level[5]          -- ADC values from ESA voltage readback for \n");
  strcat(wr_strval,"                           the voltage levels 0-4, DAC units (0-4095d)              \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      CEM_set           -- ADC value from CEM voltage DAC readback, \n");
  strcat(wr_strval,"                           (0-4095d)              \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      CEM_level         -- ADC value from CEM voltage readback, \n");
  strcat(wr_strval,"                           (0-4095d)              \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      AMP_set           -- ADC value from AMP voltage DAC readback, \n");
  strcat(wr_strval,"                           (0-4095d)              \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      MON_5V            -- ADC value from 5 volt monitor, (0-4095d)                        \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      MON_12V           -- ADC value from 12 volt monitor, (0-4095d)                        \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      SW_status         -- GEM SW status word (? bit order):\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"                              Bit 0 = HV_Enable\n");
  strcat(wr_strval,"                              Bit 1 = HV_Limit\n");
  strcat(wr_strval,"                              Bit 2 = RAM_TEST\n");
  strcat(wr_strval,"                              Bit 3 = ROM_TEST\n");
  strcat(wr_strval,"                              Bit 4 = INTERUPT_TEST\n");
  strcat(wr_strval,"                              Bit 5 = TIMING_TEST\n");
  strcat(wr_strval,"                              Bit 6 = DAC1_TEST\n");
  strcat(wr_strval,"                              Bit 7 = DAC2_TEST\n");
  strcat(wr_strval,"                              Bit 8 = DAC3_TEST\n");
  strcat(wr_strval,"                              Bit 9 = PROCESSOR_RESET\n");
  strcat(wr_strval,"                              Bits 10-11 = TEST_PULSER\n");
  strcat(wr_strval,"                              Bit 14 = LAST_SYNC_EARLY_FLAG\n");
  strcat(wr_strval,"                              Bit 15 = SIMULATOR_DATA\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      CMD_status        -- GEM CMD status word (? bit order):\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"                              Bits 0-7 = Command_Status_Counter\n");
  strcat(wr_strval,"                              Bit 8 = CMD_Status_Bad_Command_Flag\n");
  strcat(wr_strval,"                              Bit 9 = CMD_Status_Bad_Parameter_Flag\n");
  strcat(wr_strval,"                              bit 15 = AMP level stepping (1= AMP \n");
  strcat(wr_strval,"                                       stepping/SET, AMP_SET swapping \n");
  strcat(wr_strval,"                                       in effect)\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"*/\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"struct GEM_Housekeeping {\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"   uint32   sclk_seconds;\n");
  strcat(wr_strval,"   uint16   sclk_subseconds;\n");
  strcat(wr_strval,"   uint16   APID_status;\n");
  strcat(wr_strval,"   uint16   start_level;\n");
  strcat(wr_strval,"   uint16   step_size;\n");
  strcat(wr_strval,"   uint16   set[GEM_SPIN_LEVELS];\n");
  strcat(wr_strval,"   uint16   level[GEM_SPIN_LEVELS];\n");
  strcat(wr_strval,"   uint16   CEM_set;\n");
  strcat(wr_strval,"   uint16   CEM_level;\n");
  strcat(wr_strval,"   uint16   AMP_set;\n");
  strcat(wr_strval,"   uint16   MON_5V;\n");
  strcat(wr_strval,"   uint16   MON_12V;\n");
  strcat(wr_strval,"   uint16   SW_status;\n");
  strcat(wr_strval,"   uint16   CMD_status;\n");
  strcat(wr_strval,"                                       \n");
  strcat(wr_strval,"};\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"\n");
  return(0);
}
