/* The RCS version of hdfgen.pl used to create this file is: */
/* $Id: hdfgen.pl,v 1.5 2000/02/17 18:32:30 esm Exp  */

  /* An RCS (Revision Control System) header */

  /* for the include file is not on the first line. */

#include "gem_mancal.h"
#include "mfhdf.h"
#include "df.h"

int32 vgrp_id_gem_mancal;
static int32 vdata_id_gem_mancal;

static int32 sds_id_gem_mancal1;

  /* 2246 is the size of gem_mancal.h + 1 added line */
char Vgrp_descrp_GEM_ManCal[2246];

static int32 recnum_wr=0;

/****----  init create function  ----****/

int32 init_cr_gem_mancal(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{
  int32 retval=0;
  int32 vgrp_ref_w;
  int32 ann_id_w;

  int32 sds_ref_w1;
  int32 dim_sizes[3];
  int32 rank;

  int32 wr_Vgrp_desc_gem_mancal();

  void print_gem_mancal_error();

  /*         Setup a Vgroup         */
  if ((vgrp_id_gem_mancal = Vattach(hdf_fp, -1, "w"))==FAIL) {
    print_gem_mancal_error("init_cr_gem_mancal -> Vattach: Couldn't create Vgroup");
    retval = -1;
  }
  Vsetname(vgrp_id_gem_mancal, "VG_GEM_ManCal"); 
  Vsetclass(vgrp_id_gem_mancal, "VG_GEM_MANCAL");


  /*      Get the Vgroup reference     */
  if ((vgrp_ref_w = Vfind(hdf_fp, "VG_GEM_ManCal" )) ==FAIL) {
    print_gem_mancal_error("init_cr_gem_mancal -> Vfind: Couldn't get Vgrp reference");
    retval = -1;
  }
  /*      Add a description to the Vgroup      */
  wr_Vgrp_desc_gem_mancal(Vgrp_descrp_GEM_ManCal);

  if ((ann_id_w = ANcreate(an_id, DFTAG_VG, vgrp_ref_w, AN_DATA_DESC)) ==FAIL) {
    print_gem_mancal_error("init_cr_gem_mancal -> ANcreate: Can't create Vgrp description");
    retval = -1;
  }
  if ((ANwriteann(ann_id_w, Vgrp_descrp_GEM_ManCal, sizeof(Vgrp_descrp_GEM_ManCal))) ==FAIL) {
    print_gem_mancal_error("init_cr_gem_mancal -> ANwriteann: Can't write Vgrp description");
    retval = -1;
  }
  ANendaccess(ann_id_w);

  /*        Setup a Vdata        */
  if ((vdata_id_gem_mancal = VSattach(hdf_fp, -1, "w")) ==FAIL) {
    print_gem_mancal_error("init_cr_gem_mancal -> VSattach: Couldn't attach to Vdata");
    retval = -1;
  }
  VSsetname(vdata_id_gem_mancal, "GEM_ManCal");
  VSsetclass(vdata_id_gem_mancal, classname);

  /*       Insert the Vdata into the Vgroup       */
  if ((Vinsert(vgrp_id_gem_mancal, vdata_id_gem_mancal)) ==FAIL) {
    print_gem_mancal_error("init_cr_gem_mancal -> Vinsert: Couldn't insert Vdata into Vgroup");
    retval = -1;
  }

  /*    Define the fields in the Vdata    */
  if (VSfdefine(vdata_id_gem_mancal, "sclk_seconds", DFNT_UINT32, (1) )) {
    print_gem_mancal_error("init_cr_gem_mancal -> VSfdefine: Couldn't define sclk_seconds");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_mancal, "sclk_subseconds", DFNT_UINT16, (1) )) {
    print_gem_mancal_error("init_cr_gem_mancal -> VSfdefine: Couldn't define sclk_subseconds");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_mancal, "APID_status", DFNT_UINT16, (1) )) {
    print_gem_mancal_error("init_cr_gem_mancal -> VSfdefine: Couldn't define APID_status");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_mancal, "step_time", DFNT_UINT16, (1) )) {
    print_gem_mancal_error("init_cr_gem_mancal -> VSfdefine: Couldn't define step_time");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_mancal, "integ_time", DFNT_UINT16, (1) )) {
    print_gem_mancal_error("init_cr_gem_mancal -> VSfdefine: Couldn't define integ_time");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_mancal, "settle_time", DFNT_UINT16, (1) )) {
    print_gem_mancal_error("init_cr_gem_mancal -> VSfdefine: Couldn't define settle_time");
    retval = -1;
  }

  if (VSsetfields(vdata_id_gem_mancal,"sclk_seconds, sclk_subseconds, APID_status, step_time, integ_time, settle_time")){
    print_gem_mancal_error("init_cr_gem_mancal -> VSsetfields: Couldn't set fields");
    retval = -1;
  }

 /*  Create SDS's and add to the Vgroup  */
  rank = 3;
  dim_sizes[0] = SD_UNLIMITED;
  dim_sizes[1] = GEM_CEMS;
  dim_sizes[2] = GEM_SPIN_LEVELS;
  if((sds_id_gem_mancal1 = SDcreate(sd_id, "GEM_ManCal_counts", DFNT_UINT8, rank, dim_sizes)) == FAIL)
    print_gem_mancal_error("init_cr_gem_mancal -> SDcreate: Couldn't create GEM_ManCal_counts");

  /*  Add SDS to Vgroup  */
  if((sds_ref_w1 = SDidtoref(sds_id_gem_mancal1)) == FAIL)
    print_gem_mancal_error("init_cr_gem_mancal -> SDidtoref: Couldn't get ref for GEM_ManCal_counts");

  if((Vaddtagref(vgrp_id_gem_mancal, DFTAG_NDG, sds_ref_w1)) == FAIL)
    print_gem_mancal_error("init_cr_gem_mancal -> Vaddtagref: Couldn't add SDS GEM_ManCal_counts to Vgrp");

  recnum_wr = 0;

  return(retval);
}

/* Included for backwards compatibility */

int32 init_wr_gem_mancal(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{ return( init_cr_gem_mancal(hdf_fp, sd_id, an_id, classname) ); }

/******---- write function ----******/

int32 write_gem_mancal(struct GEM_ManCal GEM_ManCal_struc, int32 recnum)
{
  int32 start[3], edges[3];
  int32 retval = 0;
  uint8 *odata;

void print_gem_mancal_error();
void pack_gem_mancal();

  odata = (uint8 *) malloc(sizeof(struct GEM_ManCal));
  pack_gem_mancal(odata, &GEM_ManCal_struc);

  if(recnum!=-1) {
	recnum_wr=recnum;
	if(VSseek(vdata_id_gem_mancal, recnum)==-1) {
		print_gem_mancal_error("write_gem_mancal -> VSseek: error.");
		retval = -1;
	}
  }
  if(VSwrite(vdata_id_gem_mancal, (uint8 *)odata, 1, FULL_INTERLACE) == -1)
    print_gem_mancal_error("write_gem_mancal -> VSwrite: Couldn't write data.");

  start[0] = recnum_wr++;
  start[1] = 0;
  start[2] = 0;
  edges[0] = 1;

  edges[1] = GEM_CEMS;
  edges[2] = GEM_SPIN_LEVELS;
  if (SDwritedata(sds_id_gem_mancal1,start,NULL,edges, (VOIDP)(GEM_ManCal_struc.counts)) ==FAIL)
    print_gem_mancal_error("write_gem_mancal -> SDwritedata: Problem writing counts data.");

  memset(&GEM_ManCal_struc, 0, sizeof(struct GEM_ManCal));
  free(odata);
  return(retval);
}

/*----   close write function    ----*/

void close_wr_gem_mancal()
{
  VSdetach(vdata_id_gem_mancal);
  Vdetach(vgrp_id_gem_mancal);
  SDendaccess(sds_id_gem_mancal1);
}

/*----     init access function    ----*/

int32 init_acc_gem_mancal(int32 hdf_fp, int32 sd_id, char *access_mode)
{
  static int32 sds_index1;
  int32 vdata_ref;
  int32 num_rec;

  void print_gem_mancal_error();

  if((sds_index1=SDnametoindex(sd_id, "GEM_ManCal_counts" )) ==FAIL) {
      print_gem_mancal_error("init_acc_gem_mancal -> SDnametoindex: Couldn't find GEM_ManCal_counts");
      return(-1);
  }
  if((sds_id_gem_mancal1=SDselect(sd_id, sds_index1)) ==FAIL) {
      print_gem_mancal_error("init_acc_gem_mancal -> SDselect: Couldn't select sds_index1");
      return(-1);
  }

  if ((vdata_ref = VSfind(hdf_fp, "GEM_ManCal")) <= 0 ) {
    print_gem_mancal_error("init_acc_gem_mancal -> VSfind: Found no vdata of specified type.");
    return(0);
  }
  if ((vdata_id_gem_mancal = VSattach(hdf_fp, vdata_ref, access_mode)) ==FAIL) {
    print_gem_mancal_error("init_acc_gem_mancal -> VSattach: Couldn't attach to hdf file.");
    return(-1);
  }

  VSinquire(vdata_id_gem_mancal, &num_rec, NULL, NULL, NULL, NULL);
  if (num_rec == 0) { return(0); }


  if (VSsetfields(vdata_id_gem_mancal,"sclk_seconds, sclk_subseconds, APID_status, step_time, integ_time, settle_time")) {
      print_gem_mancal_error("init_acc_gem_mancal -> VSsetfields: Unable to set fields.");

      return(-1);
  }
  return(num_rec);
}

/* Included for backwards compatability */

int32 init_rd_gem_mancal(int32 hdf_fp, int32 sd_id, char *access_mode)
{ return ( init_acc_gem_mancal(hdf_fp, sd_id, access_mode) ); }

/******---- read function ----******/

int32 read_gem_mancal(struct GEM_ManCal *GEM_ManCal_struc, int32 recnum_rd)
{
int32 start[3], edges[3];
static int32 last_recnum = -1;
int32 maxrec;
int32 retval = 0;
uint8 *odata;

void print_gem_mancal_error();
void unpack_gem_mancal();

  if(recnum_rd==-1) recnum_rd=last_recnum+1;

  start[0] = recnum_rd;
  start[1] = 0;
  start[2] = 0;

  edges[0] = 1;

  odata = (uint8 *) malloc(sizeof(struct GEM_ManCal));
  VSinquire(vdata_id_gem_mancal, &maxrec, NULL, NULL, NULL, NULL);
  if (recnum_rd >= maxrec) return(-1);
  if (recnum_rd != last_recnum+1)
      if (VSseek(vdata_id_gem_mancal, recnum_rd)==FAIL) {
          print_gem_mancal_error("read_gem_mancal -> VSseek unsuccessful");
          retval = -1;
    }
  last_recnum = recnum_rd;

  edges[1] = GEM_CEMS;
  edges[2] = GEM_SPIN_LEVELS;

  if(SDreaddata(sds_id_gem_mancal1,start,NULL,edges, (VOIDP)(GEM_ManCal_struc->counts )) ==FAIL) {
    print_gem_mancal_error("read_gem_mancal -> SDreaddata: Couldn't read counts");
    retval = -1;
  }
  if(VSread(vdata_id_gem_mancal, (uint8 *)odata, 1, FULL_INTERLACE) ==FAIL) {
    print_gem_mancal_error("read_gem_mancal -> VSread: Couldn't read data.");
    retval = -1;
  }
  unpack_gem_mancal(odata, GEM_ManCal_struc);
  free(odata);
  return(retval);
}

/*----   close read function    ----*/

void close_rd_gem_mancal()
{
  VSdetach(vdata_id_gem_mancal);
  SDendaccess(sds_id_gem_mancal1);
}

/*----  Read V group description, function    ----*/
void rd_Vgrp_desc_gem_mancal(int32 hdf_fp, int32 an_id)
{
  int32 ann_id_r;
  int32 num_ann;
  int32 *ann_list;
  int32 vgrp_ref_r;

void print_gem_mancal_error();

  /*      Get the Vgroup reference     */
  if ((vgrp_ref_r = Vfind(hdf_fp, "VG_GEM_ManCal" )) ==FAIL)
    print_gem_mancal_error("rd_Vgrp_gem_mancal -> Vfind: Couldn't get Vgrp reference.");

  if ((num_ann = ANnumann(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r)) ==FAIL)
    print_gem_mancal_error("rd_Vgrp_gem_mancal -> ANnumann: Couldn't get number of annotations.");

printf("1numann= %d \n", num_ann);
    ann_list = HDmalloc(num_ann * sizeof(int32));
printf("1ann_list= %d \n", ann_list);
  if ((num_ann = ANannlist(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r, ann_list)) ==FAIL)
    print_gem_mancal_error("rd_Vgrp_gem_mancal -> ANannlist: Couldn't");

printf("2numann= %d \n", num_ann);
printf("2ann_list= %d \n", ann_list);
  if ((ann_id_r = ANselect(an_id, (num_ann-1), AN_DATA_DESC)) ==FAIL)
    print_gem_mancal_error("rd_Vgrp_gem_mancal -> ANselect: Couldn't");

  if (ANreadann(ann_id_r, Vgrp_descrp_GEM_ManCal, HDstrlen(Vgrp_descrp_GEM_ManCal)) ==FAIL)
    print_gem_mancal_error("rd_Vgrp_gem_mancal -> ANreadann: Couldn't");

  printf("AN: %s\n", Vgrp_descrp_GEM_ManCal);
  ANendaccess(ann_id_r);
  ANend(an_id);
}

/*----   error function    ----*/

void print_gem_mancal_error(int8 *mess)
{
  fprintf(stderr,"\nERROR in  gem_mancal.c -> %s\n", mess);
  HEprint(stderr, 0);
}

/*----   pack function    ----*/

void pack_gem_mancal(uint8 *data, struct GEM_ManCal *GEM_ManCal_ptr)
{
int32 ptr=0;

   memcpy(data+ptr, &GEM_ManCal_ptr->sclk_seconds, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &GEM_ManCal_ptr->sclk_subseconds, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_ManCal_ptr->APID_status, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_ManCal_ptr->step_time, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_ManCal_ptr->integ_time, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_ManCal_ptr->settle_time, ((2)*(1)) );
   ptr+= ((2)*(1));
}

/*----   unpack function    ----*/

void unpack_gem_mancal(uint8 *data, struct GEM_ManCal *GEM_ManCal_ptr)
{
int32 ptr=0;

   memcpy(&GEM_ManCal_ptr->sclk_seconds, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&GEM_ManCal_ptr->sclk_subseconds, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_ManCal_ptr->APID_status, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_ManCal_ptr->step_time, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_ManCal_ptr->integ_time, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_ManCal_ptr->settle_time, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
}
int32 get_vgrp_id_gem_mancal() {return(vgrp_id_gem_mancal);}

/*----   V group description function    ----*/

int32 wr_Vgrp_desc_gem_mancal(char *wr_strval)
{
  strcpy(wr_strval, "The file 'gem_mancal.h' is shown below, it was used to create the data in the Vgroup named 'VG_GEM_ManCal'.\n\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"/*    \n");
  strcat(wr_strval,"     \n");
  strcat(wr_strval,"   GNS EDR Structure definitions -- GEM Manual/Calibration Mode Data   \n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   BVS/NAIF, June 7, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"      Changed sclk_subseconds type from uint8 to uint16 to preserve \n");
  strcat(wr_strval,"      full resolution of the fractional part of SCLK. Updated \n");
  strcat(wr_strval,"      description to reflect this change. Added APID_status bit \n");
  strcat(wr_strval,"      breakdown description.\n");
  strcat(wr_strval,"     \n");
  strcat(wr_strval,"   BVS/NAIF, March 2, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"      Reformatted comments; moved dimension constants to \n");
  strcat(wr_strval,"      gnd_edr_const.h; included gnd_edr_const.h.\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   BVS/NAIF, February 17, 2000  \n");
  strcat(wr_strval,"     \n");
  strcat(wr_strval,"*/  \n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"#include \"hdfi.h\"\n");
  strcat(wr_strval,"#include \"gns_edr_const.h\"\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"/*  \n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"   GEM Manual/Calibration data structure -- APID # 33\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"      sclk_seconds      -- start SCLK seconds\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      sclk_subseconds   -- start fractions (1/65536th) of SCLK second\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      APID_status       -- APID status word (? bit order):\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"                              Bits 0-7 = Azimuth_Sampled_Indication\n");
  strcat(wr_strval,"                              Bit 8 = St_man_cal_fl\n");
  strcat(wr_strval,"                              Bit 9 = Checksum_Error_Occur_Indication\n");
  strcat(wr_strval,"                              Bit 10 = Status_Early_Sync\n");
  strcat(wr_strval,"                              Bit 11 = Status_Synthetic_Sync\n");
  strcat(wr_strval,"                              Bit 12 = Status_Test_Data\n");
  strcat(wr_strval,"                              Bits 13-15 = St_cal_spin\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      step_time         -- step time that specified in the command,\n");
  strcat(wr_strval,"                           units of 0.1 microseconds\n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      integ_time        -- detector integration time, 10 microsecond \n");
  strcat(wr_strval,"                           units\n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      settle_time       -- power supply settling time, 10 microsecond \n");
  strcat(wr_strval,"                           units\n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      counts[7][5]      -- CEM counts for each CEM/level\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"*/\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"struct GEM_ManCal {\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"   uint32   sclk_seconds;\n");
  strcat(wr_strval,"   uint16   sclk_subseconds;\n");
  strcat(wr_strval,"   uint16   APID_status;\n");
  strcat(wr_strval,"   uint16   step_time;\n");
  strcat(wr_strval,"   uint16   integ_time;\n");
  strcat(wr_strval,"   uint16   settle_time;\n");
  strcat(wr_strval,"   uint8    counts[GEM_CEMS][GEM_SPIN_LEVELS];\n");
  strcat(wr_strval,"                                       \n");
  strcat(wr_strval,"                                       \n");
  strcat(wr_strval,"};\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"\n");
  return(0);
}
