/* The RCS version of hdfgen.pl used to create this file is: */
/* $Id: hdfgen.pl,v 1.5 2000/02/17 18:32:30 esm Exp  */

  /* An RCS (Revision Control System) header */

  /* for the include file is not on the first line. */

#include "gem_raw.h"
#include "mfhdf.h"
#include "df.h"

int32 vgrp_id_gem_raw;
static int32 vdata_id_gem_raw;

static int32 sds_id_gem_raw1, sds_id_gem_raw2, sds_id_gem_raw3;

  /* 2333 is the size of gem_raw.h + 1 added line */
char Vgrp_descrp_GEM_Raw[2333];

static int32 recnum_wr=0;

/****----  init create function  ----****/

int32 init_cr_gem_raw(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{
  int32 retval=0;
  int32 vgrp_ref_w;
  int32 ann_id_w;

  int32 sds_ref_w1, sds_ref_w2, sds_ref_w3;
  int32 dim_sizes[4];
  int32 rank;

  int32 wr_Vgrp_desc_gem_raw();

  void print_gem_raw_error();

  /*         Setup a Vgroup         */
  if ((vgrp_id_gem_raw = Vattach(hdf_fp, -1, "w"))==FAIL) {
    print_gem_raw_error("init_cr_gem_raw -> Vattach: Couldn't create Vgroup");
    retval = -1;
  }
  Vsetname(vgrp_id_gem_raw, "VG_GEM_Raw"); 
  Vsetclass(vgrp_id_gem_raw, "VG_GEM_RAW");


  /*      Get the Vgroup reference     */
  if ((vgrp_ref_w = Vfind(hdf_fp, "VG_GEM_Raw" )) ==FAIL) {
    print_gem_raw_error("init_cr_gem_raw -> Vfind: Couldn't get Vgrp reference");
    retval = -1;
  }
  /*      Add a description to the Vgroup      */
  wr_Vgrp_desc_gem_raw(Vgrp_descrp_GEM_Raw);

  if ((ann_id_w = ANcreate(an_id, DFTAG_VG, vgrp_ref_w, AN_DATA_DESC)) ==FAIL) {
    print_gem_raw_error("init_cr_gem_raw -> ANcreate: Can't create Vgrp description");
    retval = -1;
  }
  if ((ANwriteann(ann_id_w, Vgrp_descrp_GEM_Raw, sizeof(Vgrp_descrp_GEM_Raw))) ==FAIL) {
    print_gem_raw_error("init_cr_gem_raw -> ANwriteann: Can't write Vgrp description");
    retval = -1;
  }
  ANendaccess(ann_id_w);

  /*        Setup a Vdata        */
  if ((vdata_id_gem_raw = VSattach(hdf_fp, -1, "w")) ==FAIL) {
    print_gem_raw_error("init_cr_gem_raw -> VSattach: Couldn't attach to Vdata");
    retval = -1;
  }
  VSsetname(vdata_id_gem_raw, "GEM_Raw");
  VSsetclass(vdata_id_gem_raw, classname);

  /*       Insert the Vdata into the Vgroup       */
  if ((Vinsert(vgrp_id_gem_raw, vdata_id_gem_raw)) ==FAIL) {
    print_gem_raw_error("init_cr_gem_raw -> Vinsert: Couldn't insert Vdata into Vgroup");
    retval = -1;
  }

  /*    Define the fields in the Vdata    */
  if (VSfdefine(vdata_id_gem_raw, "sclk_seconds", DFNT_UINT32, (1) )) {
    print_gem_raw_error("init_cr_gem_raw -> VSfdefine: Couldn't define sclk_seconds");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_raw, "sclk_subseconds", DFNT_UINT16, (1) )) {
    print_gem_raw_error("init_cr_gem_raw -> VSfdefine: Couldn't define sclk_subseconds");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_raw, "start_req", DFNT_UINT16, (GEM_AZIMUTH_SECTORS) )) {
    print_gem_raw_error("init_cr_gem_raw -> VSfdefine: Couldn't define start_req");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_raw, "step_size", DFNT_UINT16, (GEM_AZIMUTH_SECTORS) )) {
    print_gem_raw_error("init_cr_gem_raw -> VSfdefine: Couldn't define step_size");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_raw, "step_time", DFNT_UINT16, (GEM_AZIMUTH_SECTORS) )) {
    print_gem_raw_error("init_cr_gem_raw -> VSfdefine: Couldn't define step_time");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gem_raw, "angle", DFNT_UINT16, (GEM_AZIMUTH_SECTORS) )) {
    print_gem_raw_error("init_cr_gem_raw -> VSfdefine: Couldn't define angle");
    retval = -1;
  }

  if (VSsetfields(vdata_id_gem_raw,"sclk_seconds, sclk_subseconds, start_req, step_size, step_time, angle")){
    print_gem_raw_error("init_cr_gem_raw -> VSsetfields: Couldn't set fields");
    retval = -1;
  }

 /*  Create SDS's and add to the Vgroup  */
  rank = 3;
  dim_sizes[0] = SD_UNLIMITED;
  dim_sizes[1] = GEM_AZIMUTH_SECTORS;
  dim_sizes[2] = GEM_SPIN_LEVELS;
  if((sds_id_gem_raw1 = SDcreate(sd_id, "GEM_Raw_ESA_set", DFNT_UINT16, rank, dim_sizes)) == FAIL)
    print_gem_raw_error("init_cr_gem_raw -> SDcreate: Couldn't create GEM_Raw_ESA_set");

  /*  Add SDS to Vgroup  */
  if((sds_ref_w1 = SDidtoref(sds_id_gem_raw1)) == FAIL)
    print_gem_raw_error("init_cr_gem_raw -> SDidtoref: Couldn't get ref for GEM_Raw_ESA_set");

  if((Vaddtagref(vgrp_id_gem_raw, DFTAG_NDG, sds_ref_w1)) == FAIL)
    print_gem_raw_error("init_cr_gem_raw -> Vaddtagref: Couldn't add SDS GEM_Raw_ESA_set to Vgrp");

  rank = 3;
  dim_sizes[0] = SD_UNLIMITED;
  dim_sizes[1] = GEM_AZIMUTH_SECTORS;
  dim_sizes[2] = GEM_SPIN_LEVELS;
  if((sds_id_gem_raw2 = SDcreate(sd_id, "GEM_Raw_ESA_level", DFNT_UINT16, rank, dim_sizes)) == FAIL)
    print_gem_raw_error("init_cr_gem_raw -> SDcreate: Couldn't create GEM_Raw_ESA_level");

  /*  Add SDS to Vgroup  */
  if((sds_ref_w2 = SDidtoref(sds_id_gem_raw2)) == FAIL)
    print_gem_raw_error("init_cr_gem_raw -> SDidtoref: Couldn't get ref for GEM_Raw_ESA_level");

  if((Vaddtagref(vgrp_id_gem_raw, DFTAG_NDG, sds_ref_w2)) == FAIL)
    print_gem_raw_error("init_cr_gem_raw -> Vaddtagref: Couldn't add SDS GEM_Raw_ESA_level to Vgrp");

  rank = 4;
  dim_sizes[0] = SD_UNLIMITED;
  dim_sizes[1] = GEM_AZIMUTH_SECTORS;
  dim_sizes[2] = GEM_SPIN_LEVELS;
  dim_sizes[3] = GEM_CEMS;
  if((sds_id_gem_raw3 = SDcreate(sd_id, "GEM_Raw_counts", DFNT_UINT16, rank, dim_sizes)) == FAIL)
    print_gem_raw_error("init_cr_gem_raw -> SDcreate: Couldn't create GEM_Raw_counts");

  /*  Add SDS to Vgroup  */
  if((sds_ref_w3 = SDidtoref(sds_id_gem_raw3)) == FAIL)
    print_gem_raw_error("init_cr_gem_raw -> SDidtoref: Couldn't get ref for GEM_Raw_counts");

  if((Vaddtagref(vgrp_id_gem_raw, DFTAG_NDG, sds_ref_w3)) == FAIL)
    print_gem_raw_error("init_cr_gem_raw -> Vaddtagref: Couldn't add SDS GEM_Raw_counts to Vgrp");

  recnum_wr = 0;

  return(retval);
}

/* Included for backwards compatibility */

int32 init_wr_gem_raw(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{ return( init_cr_gem_raw(hdf_fp, sd_id, an_id, classname) ); }

/******---- write function ----******/

int32 write_gem_raw(struct GEM_Raw GEM_Raw_struc, int32 recnum)
{
  int32 start[4], edges[4];
  int32 retval = 0;
  uint8 *odata;

void print_gem_raw_error();
void pack_gem_raw();

  odata = (uint8 *) malloc(sizeof(struct GEM_Raw));
  pack_gem_raw(odata, &GEM_Raw_struc);

  if(recnum!=-1) {
	recnum_wr=recnum;
	if(VSseek(vdata_id_gem_raw, recnum)==-1) {
		print_gem_raw_error("write_gem_raw -> VSseek: error.");
		retval = -1;
	}
  }
  if(VSwrite(vdata_id_gem_raw, (uint8 *)odata, 1, FULL_INTERLACE) == -1)
    print_gem_raw_error("write_gem_raw -> VSwrite: Couldn't write data.");

  start[0] = recnum_wr++;
  start[1] = 0;
  start[2] = 0;
  start[3] = 0;
  edges[0] = 1;

  edges[1] = GEM_AZIMUTH_SECTORS;
  edges[2] = GEM_SPIN_LEVELS;
  if (SDwritedata(sds_id_gem_raw1,start,NULL,edges, (VOIDP)(GEM_Raw_struc.ESA_set)) ==FAIL)
    print_gem_raw_error("write_gem_raw -> SDwritedata: Problem writing ESA_set data.");

  edges[1] = GEM_AZIMUTH_SECTORS;
  edges[2] = GEM_SPIN_LEVELS;
  if (SDwritedata(sds_id_gem_raw2,start,NULL,edges, (VOIDP)(GEM_Raw_struc.ESA_level)) ==FAIL)
    print_gem_raw_error("write_gem_raw -> SDwritedata: Problem writing ESA_level data.");

  edges[1] = GEM_AZIMUTH_SECTORS;
  edges[2] = GEM_SPIN_LEVELS;
  edges[3] = GEM_CEMS;
  if (SDwritedata(sds_id_gem_raw3,start,NULL,edges, (VOIDP)(GEM_Raw_struc.counts)) ==FAIL)
    print_gem_raw_error("write_gem_raw -> SDwritedata: Problem writing counts data.");

  memset(&GEM_Raw_struc, 0, sizeof(struct GEM_Raw));
  free(odata);
  return(retval);
}

/*----   close write function    ----*/

void close_wr_gem_raw()
{
  VSdetach(vdata_id_gem_raw);
  Vdetach(vgrp_id_gem_raw);
  SDendaccess(sds_id_gem_raw1);
  SDendaccess(sds_id_gem_raw2);
  SDendaccess(sds_id_gem_raw3);
}

/*----     init access function    ----*/

int32 init_acc_gem_raw(int32 hdf_fp, int32 sd_id, char *access_mode)
{
  static int32 sds_index1;
  static int32 sds_index2;
  static int32 sds_index3;
  int32 vdata_ref;
  int32 num_rec;

  void print_gem_raw_error();

  if((sds_index1=SDnametoindex(sd_id, "GEM_Raw_ESA_set" )) ==FAIL) {
      print_gem_raw_error("init_acc_gem_raw -> SDnametoindex: Couldn't find GEM_Raw_ESA_set");
      return(-1);
  }
  if((sds_id_gem_raw1=SDselect(sd_id, sds_index1)) ==FAIL) {
      print_gem_raw_error("init_acc_gem_raw -> SDselect: Couldn't select sds_index1");
      return(-1);
  }
  if((sds_index2=SDnametoindex(sd_id, "GEM_Raw_ESA_level" )) ==FAIL) {
      print_gem_raw_error("init_acc_gem_raw -> SDnametoindex: Couldn't find GEM_Raw_ESA_level");
      return(-1);
  }
  if((sds_id_gem_raw2=SDselect(sd_id, sds_index2)) ==FAIL) {
      print_gem_raw_error("init_acc_gem_raw -> SDselect: Couldn't select sds_index2");
      return(-1);
  }
  if((sds_index3=SDnametoindex(sd_id, "GEM_Raw_counts" )) ==FAIL) {
      print_gem_raw_error("init_acc_gem_raw -> SDnametoindex: Couldn't find GEM_Raw_counts");
      return(-1);
  }
  if((sds_id_gem_raw3=SDselect(sd_id, sds_index3)) ==FAIL) {
      print_gem_raw_error("init_acc_gem_raw -> SDselect: Couldn't select sds_index3");
      return(-1);
  }

  if ((vdata_ref = VSfind(hdf_fp, "GEM_Raw")) <= 0 ) {
    print_gem_raw_error("init_acc_gem_raw -> VSfind: Found no vdata of specified type.");
    return(0);
  }
  if ((vdata_id_gem_raw = VSattach(hdf_fp, vdata_ref, access_mode)) ==FAIL) {
    print_gem_raw_error("init_acc_gem_raw -> VSattach: Couldn't attach to hdf file.");
    return(-1);
  }

  VSinquire(vdata_id_gem_raw, &num_rec, NULL, NULL, NULL, NULL);
  if (num_rec == 0) { return(0); }


  if (VSsetfields(vdata_id_gem_raw,"sclk_seconds, sclk_subseconds, start_req, step_size, step_time, angle")) {
      print_gem_raw_error("init_acc_gem_raw -> VSsetfields: Unable to set fields.");

      return(-1);
  }
  return(num_rec);
}

/* Included for backwards compatability */

int32 init_rd_gem_raw(int32 hdf_fp, int32 sd_id, char *access_mode)
{ return ( init_acc_gem_raw(hdf_fp, sd_id, access_mode) ); }

/******---- read function ----******/

int32 read_gem_raw(struct GEM_Raw *GEM_Raw_struc, int32 recnum_rd)
{
int32 start[4], edges[4];
static int32 last_recnum = -1;
int32 maxrec;
int32 retval = 0;
uint8 *odata;

void print_gem_raw_error();
void unpack_gem_raw();

  if(recnum_rd==-1) recnum_rd=last_recnum+1;

  start[0] = recnum_rd;
  start[1] = 0;
  start[2] = 0;
  start[3] = 0;

  edges[0] = 1;

  odata = (uint8 *) malloc(sizeof(struct GEM_Raw));
  VSinquire(vdata_id_gem_raw, &maxrec, NULL, NULL, NULL, NULL);
  if (recnum_rd >= maxrec) return(-1);
  if (recnum_rd != last_recnum+1)
      if (VSseek(vdata_id_gem_raw, recnum_rd)==FAIL) {
          print_gem_raw_error("read_gem_raw -> VSseek unsuccessful");
          retval = -1;
    }
  last_recnum = recnum_rd;

  edges[1] = GEM_AZIMUTH_SECTORS;
  edges[2] = GEM_SPIN_LEVELS;

  if(SDreaddata(sds_id_gem_raw1,start,NULL,edges, (VOIDP)(GEM_Raw_struc->ESA_set )) ==FAIL) {
    print_gem_raw_error("read_gem_raw -> SDreaddata: Couldn't read ESA_set");
    retval = -1;
  }
  edges[1] = GEM_AZIMUTH_SECTORS;
  edges[2] = GEM_SPIN_LEVELS;

  if(SDreaddata(sds_id_gem_raw2,start,NULL,edges, (VOIDP)(GEM_Raw_struc->ESA_level )) ==FAIL) {
    print_gem_raw_error("read_gem_raw -> SDreaddata: Couldn't read ESA_level");
    retval = -1;
  }
  edges[1] = GEM_AZIMUTH_SECTORS;
  edges[2] = GEM_SPIN_LEVELS;
  edges[3] = GEM_CEMS;

  if(SDreaddata(sds_id_gem_raw3,start,NULL,edges, (VOIDP)(GEM_Raw_struc->counts )) ==FAIL) {
    print_gem_raw_error("read_gem_raw -> SDreaddata: Couldn't read counts");
    retval = -1;
  }
  if(VSread(vdata_id_gem_raw, (uint8 *)odata, 1, FULL_INTERLACE) ==FAIL) {
    print_gem_raw_error("read_gem_raw -> VSread: Couldn't read data.");
    retval = -1;
  }
  unpack_gem_raw(odata, GEM_Raw_struc);
  free(odata);
  return(retval);
}

/*----   close read function    ----*/

void close_rd_gem_raw()
{
  VSdetach(vdata_id_gem_raw);
  SDendaccess(sds_id_gem_raw1);
  SDendaccess(sds_id_gem_raw2);
  SDendaccess(sds_id_gem_raw3);
}

/*----  Read V group description, function    ----*/
void rd_Vgrp_desc_gem_raw(int32 hdf_fp, int32 an_id)
{
  int32 ann_id_r;
  int32 num_ann;
  int32 *ann_list;
  int32 vgrp_ref_r;

void print_gem_raw_error();

  /*      Get the Vgroup reference     */
  if ((vgrp_ref_r = Vfind(hdf_fp, "VG_GEM_Raw" )) ==FAIL)
    print_gem_raw_error("rd_Vgrp_gem_raw -> Vfind: Couldn't get Vgrp reference.");

  if ((num_ann = ANnumann(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r)) ==FAIL)
    print_gem_raw_error("rd_Vgrp_gem_raw -> ANnumann: Couldn't get number of annotations.");

printf("1numann= %d \n", num_ann);
    ann_list = HDmalloc(num_ann * sizeof(int32));
printf("1ann_list= %d \n", ann_list);
  if ((num_ann = ANannlist(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r, ann_list)) ==FAIL)
    print_gem_raw_error("rd_Vgrp_gem_raw -> ANannlist: Couldn't");

printf("2numann= %d \n", num_ann);
printf("2ann_list= %d \n", ann_list);
  if ((ann_id_r = ANselect(an_id, (num_ann-1), AN_DATA_DESC)) ==FAIL)
    print_gem_raw_error("rd_Vgrp_gem_raw -> ANselect: Couldn't");

  if (ANreadann(ann_id_r, Vgrp_descrp_GEM_Raw, HDstrlen(Vgrp_descrp_GEM_Raw)) ==FAIL)
    print_gem_raw_error("rd_Vgrp_gem_raw -> ANreadann: Couldn't");

  printf("AN: %s\n", Vgrp_descrp_GEM_Raw);
  ANendaccess(ann_id_r);
  ANend(an_id);
}

/*----   error function    ----*/

void print_gem_raw_error(int8 *mess)
{
  fprintf(stderr,"\nERROR in  gem_raw.c -> %s\n", mess);
  HEprint(stderr, 0);
}

/*----   pack function    ----*/

void pack_gem_raw(uint8 *data, struct GEM_Raw *GEM_Raw_ptr)
{
int32 ptr=0;

   memcpy(data+ptr, &GEM_Raw_ptr->sclk_seconds, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &GEM_Raw_ptr->sclk_subseconds, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GEM_Raw_ptr->start_req[0], ((2)*(GEM_AZIMUTH_SECTORS)) );
   ptr+= ((2)*(GEM_AZIMUTH_SECTORS));
   memcpy(data+ptr, &GEM_Raw_ptr->step_size[0], ((2)*(GEM_AZIMUTH_SECTORS)) );
   ptr+= ((2)*(GEM_AZIMUTH_SECTORS));
   memcpy(data+ptr, &GEM_Raw_ptr->step_time[0], ((2)*(GEM_AZIMUTH_SECTORS)) );
   ptr+= ((2)*(GEM_AZIMUTH_SECTORS));
   memcpy(data+ptr, &GEM_Raw_ptr->angle[0], ((2)*(GEM_AZIMUTH_SECTORS)) );
   ptr+= ((2)*(GEM_AZIMUTH_SECTORS));
}

/*----   unpack function    ----*/

void unpack_gem_raw(uint8 *data, struct GEM_Raw *GEM_Raw_ptr)
{
int32 ptr=0;

   memcpy(&GEM_Raw_ptr->sclk_seconds, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&GEM_Raw_ptr->sclk_subseconds, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GEM_Raw_ptr->start_req[0], data+ptr,  ((2)*(GEM_AZIMUTH_SECTORS)) );
   ptr+= ((2)*(GEM_AZIMUTH_SECTORS));
   memcpy(&GEM_Raw_ptr->step_size[0], data+ptr,  ((2)*(GEM_AZIMUTH_SECTORS)) );
   ptr+= ((2)*(GEM_AZIMUTH_SECTORS));
   memcpy(&GEM_Raw_ptr->step_time[0], data+ptr,  ((2)*(GEM_AZIMUTH_SECTORS)) );
   ptr+= ((2)*(GEM_AZIMUTH_SECTORS));
   memcpy(&GEM_Raw_ptr->angle[0], data+ptr,  ((2)*(GEM_AZIMUTH_SECTORS)) );
   ptr+= ((2)*(GEM_AZIMUTH_SECTORS));
}
int32 get_vgrp_id_gem_raw() {return(vgrp_id_gem_raw);}

/*----   V group description function    ----*/

int32 wr_Vgrp_desc_gem_raw(char *wr_strval)
{
  strcpy(wr_strval, "The file 'gem_raw.h' is shown below, it was used to create the data in the Vgroup named 'VG_GEM_Raw'.\n\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"/*  \n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"   GNS EDR Structure definitions -- GEM Raw Count Data \n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"   BVS/NAIF, November 11, 2000\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"*/\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"#include \"hdfi.h\"\n");
  strcat(wr_strval,"#include \"gns_edr_const.h\"\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"/*  \n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"   GEM raw count structure -- APID # 41\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"      sclk_seconds         -- spin start SCLK seconds\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      sclk_subseconds      -- spin start fractions (1/65536th) of \n");
  strcat(wr_strval,"                              SCLK second\n");
  strcat(wr_strval,"                              \n");
  strcat(wr_strval,"      start_req[24]        -- voltage requested start level that \n");
  strcat(wr_strval,"                              was specified in acquire or manual \n");
  strcat(wr_strval,"                              command, DAC units (0-4095d)\n");
  strcat(wr_strval,"                              \n");
  strcat(wr_strval,"      step_size[24]        -- voltage level step size that was \n");
  strcat(wr_strval,"                              specified in command, units of 00.001 \n");
  strcat(wr_strval,"                              percent, 00 if manual acquisition\n");
  strcat(wr_strval,"                              \n");
  strcat(wr_strval,"      step_time[24]        -- step time that was specified in the \n");
  strcat(wr_strval,"                              command, units of 0.1 microseconds.\n");
  strcat(wr_strval,"                              \n");
  strcat(wr_strval,"      angle[24]            -- sequence number implying angular \n");
  strcat(wr_strval,"                              position of data set (0-23)\n");
  strcat(wr_strval,"                              \n");
  strcat(wr_strval,"      ESA_set[24][5]       -- ADC value from ESA voltage DAC \n");
  strcat(wr_strval,"                              readback for each sector/voltage \n");
  strcat(wr_strval,"                              level (0-4095d)\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      ESA_level[24][5]     -- ADC value from ESA voltage readback \n");
  strcat(wr_strval,"                              for each sector/voltage level (0-4095d)\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      counts[24][5][7]     -- CEM counts for each sector/voltage\n");
  strcat(wr_strval,"                              level/CEM, (0-65535)\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"*/\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"struct GEM_Raw {\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"   uint32   sclk_seconds;\n");
  strcat(wr_strval,"   uint16   sclk_subseconds;\n");
  strcat(wr_strval,"   uint16   start_req[GEM_AZIMUTH_SECTORS];\n");
  strcat(wr_strval,"   uint16   step_size[GEM_AZIMUTH_SECTORS];         \n");
  strcat(wr_strval,"   uint16   step_time[GEM_AZIMUTH_SECTORS];          \n");
  strcat(wr_strval,"   uint16   angle[GEM_AZIMUTH_SECTORS];              \n");
  strcat(wr_strval,"   uint16   ESA_set[GEM_AZIMUTH_SECTORS][GEM_SPIN_LEVELS];\n");
  strcat(wr_strval,"   uint16   ESA_level[GEM_AZIMUTH_SECTORS][GEM_SPIN_LEVELS];\n");
  strcat(wr_strval,"   uint16   counts[GEM_AZIMUTH_SECTORS][GEM_SPIN_LEVELS][GEM_CEMS];\n");
  strcat(wr_strval,"                                       \n");
  strcat(wr_strval,"};\n");
  return(0);
}
