/* The RCS version of hdfgen.pl used to create this file is: */
/* $Id: hdfgen.pl,v 1.5 2000/02/17 18:32:30 esm Exp  */

  /* An RCS (Revision Control System) header */

  /* for the include file is not on the first line. */

#include "gim_diag.h"
#include "mfhdf.h"
#include "df.h"

int32 vgrp_id_gim_diag;
static int32 vdata_id_gim_diag;

static int32 sds_id_gim_diag1;

  /* 2701 is the size of gim_diag.h + 1 added line */
char Vgrp_descrp_GIM_Diagnostic[2701];

static int32 recnum_wr=0;

/****----  init create function  ----****/

int32 init_cr_gim_diag(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{
  int32 retval=0;
  int32 vgrp_ref_w;
  int32 ann_id_w;

  int32 sds_ref_w1;
  int32 dim_sizes[4];
  int32 rank;

  int32 wr_Vgrp_desc_gim_diag();

  void print_gim_diag_error();

  /*         Setup a Vgroup         */
  if ((vgrp_id_gim_diag = Vattach(hdf_fp, -1, "w"))==FAIL) {
    print_gim_diag_error("init_cr_gim_diag -> Vattach: Couldn't create Vgroup");
    retval = -1;
  }
  Vsetname(vgrp_id_gim_diag, "VG_GIM_Diagnostic"); 
  Vsetclass(vgrp_id_gim_diag, "VG_GIM_DIAG");


  /*      Get the Vgroup reference     */
  if ((vgrp_ref_w = Vfind(hdf_fp, "VG_GIM_Diagnostic" )) ==FAIL) {
    print_gim_diag_error("init_cr_gim_diag -> Vfind: Couldn't get Vgrp reference");
    retval = -1;
  }
  /*      Add a description to the Vgroup      */
  wr_Vgrp_desc_gim_diag(Vgrp_descrp_GIM_Diagnostic);

  if ((ann_id_w = ANcreate(an_id, DFTAG_VG, vgrp_ref_w, AN_DATA_DESC)) ==FAIL) {
    print_gim_diag_error("init_cr_gim_diag -> ANcreate: Can't create Vgrp description");
    retval = -1;
  }
  if ((ANwriteann(ann_id_w, Vgrp_descrp_GIM_Diagnostic, sizeof(Vgrp_descrp_GIM_Diagnostic))) ==FAIL) {
    print_gim_diag_error("init_cr_gim_diag -> ANwriteann: Can't write Vgrp description");
    retval = -1;
  }
  ANendaccess(ann_id_w);

  /*        Setup a Vdata        */
  if ((vdata_id_gim_diag = VSattach(hdf_fp, -1, "w")) ==FAIL) {
    print_gim_diag_error("init_cr_gim_diag -> VSattach: Couldn't attach to Vdata");
    retval = -1;
  }
  VSsetname(vdata_id_gim_diag, "GIM_Diagnostic");
  VSsetclass(vdata_id_gim_diag, classname);

  /*       Insert the Vdata into the Vgroup       */
  if ((Vinsert(vgrp_id_gim_diag, vdata_id_gim_diag)) ==FAIL) {
    print_gim_diag_error("init_cr_gim_diag -> Vinsert: Couldn't insert Vdata into Vgroup");
    retval = -1;
  }

  /*    Define the fields in the Vdata    */
  if (VSfdefine(vdata_id_gim_diag, "APID_status", DFNT_UINT16, (1) )) {
    print_gim_diag_error("init_cr_gim_diag -> VSfdefine: Couldn't define APID_status");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gim_diag, "sclk_seconds", DFNT_UINT32, (GIM_SPINS) )) {
    print_gim_diag_error("init_cr_gim_diag -> VSfdefine: Couldn't define sclk_seconds");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gim_diag, "sclk_subseconds", DFNT_UINT16, (GIM_SPINS) )) {
    print_gim_diag_error("init_cr_gim_diag -> VSfdefine: Couldn't define sclk_subseconds");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gim_diag, "step_time", DFNT_UINT16, (GIM_SPINS) )) {
    print_gim_diag_error("init_cr_gim_diag -> VSfdefine: Couldn't define step_time");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gim_diag, "level", DFNT_UINT16, (GIM_SPINS) )) {
    print_gim_diag_error("init_cr_gim_diag -> VSfdefine: Couldn't define level");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gim_diag, "step_size", DFNT_UINT16, (GIM_SPINS) )) {
    print_gim_diag_error("init_cr_gim_diag -> VSfdefine: Couldn't define step_size");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gim_diag, "integ_time", DFNT_UINT16, (1) )) {
    print_gim_diag_error("init_cr_gim_diag -> VSfdefine: Couldn't define integ_time");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gim_diag, "settle_time", DFNT_UINT16, (1) )) {
    print_gim_diag_error("init_cr_gim_diag -> VSfdefine: Couldn't define settle_time");
    retval = -1;
  }
  if (VSfdefine(vdata_id_gim_diag, "ESA_level", DFNT_UINT16, (GIM_CYCLE_LEVELS) )) {
    print_gim_diag_error("init_cr_gim_diag -> VSfdefine: Couldn't define ESA_level");
    retval = -1;
  }

  if (VSsetfields(vdata_id_gim_diag,"APID_status, sclk_seconds, sclk_subseconds, step_time, level, step_size, integ_time, settle_time, ESA_level")){
    print_gim_diag_error("init_cr_gim_diag -> VSsetfields: Couldn't set fields");
    retval = -1;
  }

 /*  Create SDS's and add to the Vgroup  */
  rank = 4;
  dim_sizes[0] = SD_UNLIMITED;
  dim_sizes[1] = GIM_AZIMUTH_SECTORS;
  dim_sizes[2] = GIM_CEMS;
  dim_sizes[3] = GIM_CYCLE_LEVELS;
  if((sds_id_gim_diag1 = SDcreate(sd_id, "GIM_Diagnostic_counts", DFNT_UINT8, rank, dim_sizes)) == FAIL)
    print_gim_diag_error("init_cr_gim_diag -> SDcreate: Couldn't create GIM_Diagnostic_counts");

  /*  Add SDS to Vgroup  */
  if((sds_ref_w1 = SDidtoref(sds_id_gim_diag1)) == FAIL)
    print_gim_diag_error("init_cr_gim_diag -> SDidtoref: Couldn't get ref for GIM_Diagnostic_counts");

  if((Vaddtagref(vgrp_id_gim_diag, DFTAG_NDG, sds_ref_w1)) == FAIL)
    print_gim_diag_error("init_cr_gim_diag -> Vaddtagref: Couldn't add SDS GIM_Diagnostic_counts to Vgrp");

  recnum_wr = 0;

  return(retval);
}

/* Included for backwards compatibility */

int32 init_wr_gim_diag(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{ return( init_cr_gim_diag(hdf_fp, sd_id, an_id, classname) ); }

/******---- write function ----******/

int32 write_gim_diag(struct GIM_Diagnostic GIM_Diagnostic_struc, int32 recnum)
{
  int32 start[4], edges[4];
  int32 retval = 0;
  uint8 *odata;

void print_gim_diag_error();
void pack_gim_diag();

  odata = (uint8 *) malloc(sizeof(struct GIM_Diagnostic));
  pack_gim_diag(odata, &GIM_Diagnostic_struc);

  if(recnum!=-1) {
	recnum_wr=recnum;
	if(VSseek(vdata_id_gim_diag, recnum)==-1) {
		print_gim_diag_error("write_gim_diag -> VSseek: error.");
		retval = -1;
	}
  }
  if(VSwrite(vdata_id_gim_diag, (uint8 *)odata, 1, FULL_INTERLACE) == -1)
    print_gim_diag_error("write_gim_diag -> VSwrite: Couldn't write data.");

  start[0] = recnum_wr++;
  start[1] = 0;
  start[2] = 0;
  start[3] = 0;
  edges[0] = 1;

  edges[1] = GIM_AZIMUTH_SECTORS;
  edges[2] = GIM_CEMS;
  edges[3] = GIM_CYCLE_LEVELS;
  if (SDwritedata(sds_id_gim_diag1,start,NULL,edges, (VOIDP)(GIM_Diagnostic_struc.counts)) ==FAIL)
    print_gim_diag_error("write_gim_diag -> SDwritedata: Problem writing counts data.");

  memset(&GIM_Diagnostic_struc, 0, sizeof(struct GIM_Diagnostic));
  free(odata);
  return(retval);
}

/*----   close write function    ----*/

void close_wr_gim_diag()
{
  VSdetach(vdata_id_gim_diag);
  Vdetach(vgrp_id_gim_diag);
  SDendaccess(sds_id_gim_diag1);
}

/*----     init access function    ----*/

int32 init_acc_gim_diag(int32 hdf_fp, int32 sd_id, char *access_mode)
{
  static int32 sds_index1;
  int32 vdata_ref;
  int32 num_rec;

  void print_gim_diag_error();

  if((sds_index1=SDnametoindex(sd_id, "GIM_Diagnostic_counts" )) ==FAIL) {
      print_gim_diag_error("init_acc_gim_diag -> SDnametoindex: Couldn't find GIM_Diagnostic_counts");
      return(-1);
  }
  if((sds_id_gim_diag1=SDselect(sd_id, sds_index1)) ==FAIL) {
      print_gim_diag_error("init_acc_gim_diag -> SDselect: Couldn't select sds_index1");
      return(-1);
  }

  if ((vdata_ref = VSfind(hdf_fp, "GIM_Diagnostic")) <= 0 ) {
    print_gim_diag_error("init_acc_gim_diag -> VSfind: Found no vdata of specified type.");
    return(0);
  }
  if ((vdata_id_gim_diag = VSattach(hdf_fp, vdata_ref, access_mode)) ==FAIL) {
    print_gim_diag_error("init_acc_gim_diag -> VSattach: Couldn't attach to hdf file.");
    return(-1);
  }

  VSinquire(vdata_id_gim_diag, &num_rec, NULL, NULL, NULL, NULL);
  if (num_rec == 0) { return(0); }


  if (VSsetfields(vdata_id_gim_diag,"APID_status, sclk_seconds, sclk_subseconds, step_time, level, step_size, integ_time, settle_time, ESA_level")) {
      print_gim_diag_error("init_acc_gim_diag -> VSsetfields: Unable to set fields.");

      return(-1);
  }
  return(num_rec);
}

/* Included for backwards compatability */

int32 init_rd_gim_diag(int32 hdf_fp, int32 sd_id, char *access_mode)
{ return ( init_acc_gim_diag(hdf_fp, sd_id, access_mode) ); }

/******---- read function ----******/

int32 read_gim_diag(struct GIM_Diagnostic *GIM_Diagnostic_struc, int32 recnum_rd)
{
int32 start[4], edges[4];
static int32 last_recnum = -1;
int32 maxrec;
int32 retval = 0;
uint8 *odata;

void print_gim_diag_error();
void unpack_gim_diag();

  if(recnum_rd==-1) recnum_rd=last_recnum+1;

  start[0] = recnum_rd;
  start[1] = 0;
  start[2] = 0;
  start[3] = 0;

  edges[0] = 1;

  odata = (uint8 *) malloc(sizeof(struct GIM_Diagnostic));
  VSinquire(vdata_id_gim_diag, &maxrec, NULL, NULL, NULL, NULL);
  if (recnum_rd >= maxrec) return(-1);
  if (recnum_rd != last_recnum+1)
      if (VSseek(vdata_id_gim_diag, recnum_rd)==FAIL) {
          print_gim_diag_error("read_gim_diag -> VSseek unsuccessful");
          retval = -1;
    }
  last_recnum = recnum_rd;

  edges[1] = GIM_AZIMUTH_SECTORS;
  edges[2] = GIM_CEMS;
  edges[3] = GIM_CYCLE_LEVELS;

  if(SDreaddata(sds_id_gim_diag1,start,NULL,edges, (VOIDP)(GIM_Diagnostic_struc->counts )) ==FAIL) {
    print_gim_diag_error("read_gim_diag -> SDreaddata: Couldn't read counts");
    retval = -1;
  }
  if(VSread(vdata_id_gim_diag, (uint8 *)odata, 1, FULL_INTERLACE) ==FAIL) {
    print_gim_diag_error("read_gim_diag -> VSread: Couldn't read data.");
    retval = -1;
  }
  unpack_gim_diag(odata, GIM_Diagnostic_struc);
  free(odata);
  return(retval);
}

/*----   close read function    ----*/

void close_rd_gim_diag()
{
  VSdetach(vdata_id_gim_diag);
  SDendaccess(sds_id_gim_diag1);
}

/*----  Read V group description, function    ----*/
void rd_Vgrp_desc_gim_diag(int32 hdf_fp, int32 an_id)
{
  int32 ann_id_r;
  int32 num_ann;
  int32 *ann_list;
  int32 vgrp_ref_r;

void print_gim_diag_error();

  /*      Get the Vgroup reference     */
  if ((vgrp_ref_r = Vfind(hdf_fp, "VG_GIM_Diagnostic" )) ==FAIL)
    print_gim_diag_error("rd_Vgrp_gim_diag -> Vfind: Couldn't get Vgrp reference.");

  if ((num_ann = ANnumann(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r)) ==FAIL)
    print_gim_diag_error("rd_Vgrp_gim_diag -> ANnumann: Couldn't get number of annotations.");

printf("1numann= %d \n", num_ann);
    ann_list = HDmalloc(num_ann * sizeof(int32));
printf("1ann_list= %d \n", ann_list);
  if ((num_ann = ANannlist(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r, ann_list)) ==FAIL)
    print_gim_diag_error("rd_Vgrp_gim_diag -> ANannlist: Couldn't");

printf("2numann= %d \n", num_ann);
printf("2ann_list= %d \n", ann_list);
  if ((ann_id_r = ANselect(an_id, (num_ann-1), AN_DATA_DESC)) ==FAIL)
    print_gim_diag_error("rd_Vgrp_gim_diag -> ANselect: Couldn't");

  if (ANreadann(ann_id_r, Vgrp_descrp_GIM_Diagnostic, HDstrlen(Vgrp_descrp_GIM_Diagnostic)) ==FAIL)
    print_gim_diag_error("rd_Vgrp_gim_diag -> ANreadann: Couldn't");

  printf("AN: %s\n", Vgrp_descrp_GIM_Diagnostic);
  ANendaccess(ann_id_r);
  ANend(an_id);
}

/*----   error function    ----*/

void print_gim_diag_error(int8 *mess)
{
  fprintf(stderr,"\nERROR in  gim_diag.c -> %s\n", mess);
  HEprint(stderr, 0);
}

/*----   pack function    ----*/

void pack_gim_diag(uint8 *data, struct GIM_Diagnostic *GIM_Diagnostic_ptr)
{
int32 ptr=0;

   memcpy(data+ptr, &GIM_Diagnostic_ptr->APID_status, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GIM_Diagnostic_ptr->sclk_seconds[0], ((4)*(GIM_SPINS)) );
   ptr+= ((4)*(GIM_SPINS));
   memcpy(data+ptr, &GIM_Diagnostic_ptr->sclk_subseconds[0], ((2)*(GIM_SPINS)) );
   ptr+= ((2)*(GIM_SPINS));
   memcpy(data+ptr, &GIM_Diagnostic_ptr->step_time[0], ((2)*(GIM_SPINS)) );
   ptr+= ((2)*(GIM_SPINS));
   memcpy(data+ptr, &GIM_Diagnostic_ptr->level[0], ((2)*(GIM_SPINS)) );
   ptr+= ((2)*(GIM_SPINS));
   memcpy(data+ptr, &GIM_Diagnostic_ptr->step_size[0], ((2)*(GIM_SPINS)) );
   ptr+= ((2)*(GIM_SPINS));
   memcpy(data+ptr, &GIM_Diagnostic_ptr->integ_time, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GIM_Diagnostic_ptr->settle_time, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &GIM_Diagnostic_ptr->ESA_level[0], ((2)*(GIM_CYCLE_LEVELS)) );
   ptr+= ((2)*(GIM_CYCLE_LEVELS));
}

/*----   unpack function    ----*/

void unpack_gim_diag(uint8 *data, struct GIM_Diagnostic *GIM_Diagnostic_ptr)
{
int32 ptr=0;

   memcpy(&GIM_Diagnostic_ptr->APID_status, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GIM_Diagnostic_ptr->sclk_seconds[0], data+ptr,  ((4)*(GIM_SPINS)) );
   ptr+= ((4)*(GIM_SPINS));
   memcpy(&GIM_Diagnostic_ptr->sclk_subseconds[0], data+ptr,  ((2)*(GIM_SPINS)) );
   ptr+= ((2)*(GIM_SPINS));
   memcpy(&GIM_Diagnostic_ptr->step_time[0], data+ptr,  ((2)*(GIM_SPINS)) );
   ptr+= ((2)*(GIM_SPINS));
   memcpy(&GIM_Diagnostic_ptr->level[0], data+ptr,  ((2)*(GIM_SPINS)) );
   ptr+= ((2)*(GIM_SPINS));
   memcpy(&GIM_Diagnostic_ptr->step_size[0], data+ptr,  ((2)*(GIM_SPINS)) );
   ptr+= ((2)*(GIM_SPINS));
   memcpy(&GIM_Diagnostic_ptr->integ_time, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GIM_Diagnostic_ptr->settle_time, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&GIM_Diagnostic_ptr->ESA_level[0], data+ptr,  ((2)*(GIM_CYCLE_LEVELS)) );
   ptr+= ((2)*(GIM_CYCLE_LEVELS));
}
int32 get_vgrp_id_gim_diag() {return(vgrp_id_gim_diag);}

/*----   V group description function    ----*/

int32 wr_Vgrp_desc_gim_diag(char *wr_strval)
{
  strcpy(wr_strval, "The file 'gim_diag.h' is shown below, it was used to create the data in the Vgroup named 'VG_GIM_Diagnostic'.\n\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"/*  \n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"   GNS EDR Structure definitions -- GIM Diagnostic Mode Data \n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"   BVS/NAIF, June 7, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"      Changed sclk_subseconds type from uint8 to uint16 to preserve \n");
  strcat(wr_strval,"      full resolution of the fractional part of SCLK. Updated \n");
  strcat(wr_strval,"      description to reflect this change. Added APID_status bit \n");
  strcat(wr_strval,"      breakdown description.\n");
  strcat(wr_strval,"        \n");
  strcat(wr_strval,"   BVS/NAIF, March 2, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"      Reformatted comments; moved dimension constants to \n");
  strcat(wr_strval,"      gnd_edr_const.h; included gnd_edr_const.h.\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   BVS/NAIF, February 17, 2000\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"*/\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"#include \"hdfi.h\"\n");
  strcat(wr_strval,"#include \"gns_edr_const.h\"\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"/*  \n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"   GIM Diagnostic data structure -- APID # 34\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"      APID_status          -- APID status word (? bit order):\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"                                 Bits 5-10 = Status_Checksum_Error\n");
  strcat(wr_strval,"                                 Bit 0 = Status_Early_Sync\n");
  strcat(wr_strval,"                                 Bit 1 = Status_Synthetic_Sync\n");
  strcat(wr_strval,"                                 Bit 2 = Status_Test_Data\n");
  strcat(wr_strval,"                                 Bit 3 = Status_Use_Data\n");
  strcat(wr_strval,"                                 bit 4 = Status_Sub_Mode\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      sclk_seconds[4]      -- 1-4 spin start SCLK seconds\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      sclk_subseconds[4]   -- 1-4 spin start fractions (1/65536th) of \n");
  strcat(wr_strval,"                              SCLK second\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      step_time[4]         -- 1-4 spin step time that specified in the \n");
  strcat(wr_strval,"                              command, units of 0.1 microseconds\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      level[4]             -- 1-4 spin ADC values from ESA voltage \n");
  strcat(wr_strval,"                              readback for the voltage level, DAC \n");
  strcat(wr_strval,"                              units (0-4095d)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      step_size[4]         -- voltage level step size that was \n");
  strcat(wr_strval,"                              specified in command, units of 0.01 \n");
  strcat(wr_strval,"                              percent\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      integ_time           -- detector integration time, 10 microsecond\n");
  strcat(wr_strval,"                              units\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      settle_time          -- power supply settling time, 10 microsecond\n");
  strcat(wr_strval,"                              units\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      ESA_level[40]        -- ESA levels, (DAC units (0-4095d)?)\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      counts[40][8][40]    -- CEM counts for each sector/CEM/level\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"*/\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"struct GIM_Diagnostic {\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"   uint16   APID_status;\n");
  strcat(wr_strval,"   uint32   sclk_seconds[GIM_SPINS];\n");
  strcat(wr_strval,"   uint16   sclk_subseconds[GIM_SPINS];\n");
  strcat(wr_strval,"   uint16   step_time[GIM_SPINS];\n");
  strcat(wr_strval,"   uint16   level[GIM_SPINS];\n");
  strcat(wr_strval,"   uint16   step_size[GIM_SPINS];\n");
  strcat(wr_strval,"   uint16   integ_time;\n");
  strcat(wr_strval,"   uint16   settle_time;\n");
  strcat(wr_strval,"   uint16   ESA_level[GIM_CYCLE_LEVELS];\n");
  strcat(wr_strval,"   uint8    counts[GIM_AZIMUTH_SECTORS][GIM_CEMS][GIM_CYCLE_LEVELS];\n");
  strcat(wr_strval,"                                       \n");
  strcat(wr_strval,"};\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"\n");
  return(0);
}
