/* The RCS version of hdfgen.pl used to create this file is: */
/* $Id: hdfgen.pl,v 1.5 2000/02/17 18:32:30 esm Exp  */

  /* An RCS (Revision Control System) header */

  /* for the include file is not on the first line. */

#include "mec_f1d.h"
#include "df.h"

int32 vgrp_id_mec_f1d;
static int32 vdata_id_mec_f1d;

  /* 853 is the size of mec_f1d.h + 1 added line */
char Vgrp_descrp_MEC_f1d[853];

/****----  init create function  ----****/

int32 init_cr_mec_f1d(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{
  int32 retval=0;
  int32 vgrp_ref_w;
  int32 ann_id_w;
  int32 wr_Vgrp_desc_mec_f1d();

  void print_mec_f1d_error();

  /*         Setup a Vgroup         */
  if ((vgrp_id_mec_f1d = Vattach(hdf_fp, -1, "w"))==FAIL) {
    print_mec_f1d_error("init_cr_mec_f1d -> Vattach: Couldn't create Vgroup");
    retval = -1;
  }
  Vsetname(vgrp_id_mec_f1d, "VG_MEC_f1d"); 
  Vsetclass(vgrp_id_mec_f1d, "VG_MEC_F1D");


  /*      Get the Vgroup reference     */
  if ((vgrp_ref_w = Vfind(hdf_fp, "VG_MEC_f1d" )) ==FAIL) {
    print_mec_f1d_error("init_cr_mec_f1d -> Vfind: Couldn't get Vgrp reference");
    retval = -1;
  }
  /*      Add a description to the Vgroup      */
  wr_Vgrp_desc_mec_f1d(Vgrp_descrp_MEC_f1d);

  if ((ann_id_w = ANcreate(an_id, DFTAG_VG, vgrp_ref_w, AN_DATA_DESC)) ==FAIL) {
    print_mec_f1d_error("init_cr_mec_f1d -> ANcreate: Can't create Vgrp description");
    retval = -1;
  }
  if ((ANwriteann(ann_id_w, Vgrp_descrp_MEC_f1d, sizeof(Vgrp_descrp_MEC_f1d))) ==FAIL) {
    print_mec_f1d_error("init_cr_mec_f1d -> ANwriteann: Can't write Vgrp description");
    retval = -1;
  }
  ANendaccess(ann_id_w);

  /*        Setup a Vdata        */
  if ((vdata_id_mec_f1d = VSattach(hdf_fp, -1, "w")) ==FAIL) {
    print_mec_f1d_error("init_cr_mec_f1d -> VSattach: Couldn't attach to Vdata");
    retval = -1;
  }
  VSsetname(vdata_id_mec_f1d, "MEC_f1d");
  VSsetclass(vdata_id_mec_f1d, classname);

  /*       Insert the Vdata into the Vgroup       */
  if ((Vinsert(vgrp_id_mec_f1d, vdata_id_mec_f1d)) ==FAIL) {
    print_mec_f1d_error("init_cr_mec_f1d -> Vinsert: Couldn't insert Vdata into Vgroup");
    retval = -1;
  }

  /*    Define the fields in the Vdata    */
  if (VSfdefine(vdata_id_mec_f1d, "sclk_seconds", DFNT_UINT32, (1) )) {
    print_mec_f1d_error("init_cr_mec_f1d -> VSfdefine: Couldn't define sclk_seconds");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_f1d, "sclk_subseconds", DFNT_UINT16, (1) )) {
    print_mec_f1d_error("init_cr_mec_f1d -> VSfdefine: Couldn't define sclk_subseconds");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_f1d, "f1d_ion_distr", DFNT_FLOAT32, (MEC_F1D_ELEMENTS) )) {
    print_mec_f1d_error("init_cr_mec_f1d -> VSfdefine: Couldn't define f1d_ion_distr");
    retval = -1;
  }

  if (VSsetfields(vdata_id_mec_f1d,"sclk_seconds, sclk_subseconds, f1d_ion_distr")){
    print_mec_f1d_error("init_cr_mec_f1d -> VSsetfields: Couldn't set fields");
    retval = -1;
  }

  return(retval);
}

/* Included for backwards compatibility */

int32 init_wr_mec_f1d(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{ return( init_cr_mec_f1d(hdf_fp, sd_id, an_id, classname) ); }

/******---- write function ----******/

int32 write_mec_f1d(struct MEC_f1d MEC_f1d_struc, int32 recnum)
{
  int32 retval = 0;
  uint8 *odata;

void print_mec_f1d_error();
void pack_mec_f1d();

  odata = (uint8 *) malloc(sizeof(struct MEC_f1d));
  pack_mec_f1d(odata, &MEC_f1d_struc);

  if(recnum!=-1) {
	if(VSseek(vdata_id_mec_f1d, recnum)==-1) {
		print_mec_f1d_error("write_mec_f1d -> VSseek: error.");
		retval = -1;
	}
  }
  if(VSwrite(vdata_id_mec_f1d, (uint8 *)odata, 1, FULL_INTERLACE) == -1)
    print_mec_f1d_error("write_mec_f1d -> VSwrite: Couldn't write data.");

  memset(&MEC_f1d_struc, 0, sizeof(struct MEC_f1d));
  free(odata);
  return(retval);
}

/*----   close write function    ----*/

void close_wr_mec_f1d()
{
  VSdetach(vdata_id_mec_f1d);
  Vdetach(vgrp_id_mec_f1d);
}

/*----     init access function    ----*/

int32 init_acc_mec_f1d(int32 hdf_fp, int32 sd_id, char *access_mode)
{
  int32 vdata_ref;
  int32 num_rec;

  void print_mec_f1d_error();


  if ((vdata_ref = VSfind(hdf_fp, "MEC_f1d")) <= 0 ) {
    print_mec_f1d_error("init_acc_mec_f1d -> VSfind: Found no vdata of specified type.");
    return(0);
  }
  if ((vdata_id_mec_f1d = VSattach(hdf_fp, vdata_ref, access_mode)) ==FAIL) {
    print_mec_f1d_error("init_acc_mec_f1d -> VSattach: Couldn't attach to hdf file.");
    return(-1);
  }

  VSinquire(vdata_id_mec_f1d, &num_rec, NULL, NULL, NULL, NULL);
  if (num_rec == 0) { return(0); }


  if (VSsetfields(vdata_id_mec_f1d,"sclk_seconds, sclk_subseconds, f1d_ion_distr")) {
      print_mec_f1d_error("init_acc_mec_f1d -> VSsetfields: Unable to set fields.");

      return(-1);
  }
  return(num_rec);
}

/* Included for backwards compatability */

int32 init_rd_mec_f1d(int32 hdf_fp, int32 sd_id, char *access_mode)
{ return ( init_acc_mec_f1d(hdf_fp, sd_id, access_mode) ); }

/******---- read function ----******/

int32 read_mec_f1d(struct MEC_f1d *MEC_f1d_struc, int32 recnum_rd)
{
static int32 last_recnum = -1;
int32 maxrec;
int32 retval = 0;
uint8 *odata;

void print_mec_f1d_error();
void unpack_mec_f1d();

  if(recnum_rd==-1) recnum_rd=last_recnum+1;

  odata = (uint8 *) malloc(sizeof(struct MEC_f1d));
  VSinquire(vdata_id_mec_f1d, &maxrec, NULL, NULL, NULL, NULL);
  if (recnum_rd >= maxrec) return(-1);
  if (recnum_rd != last_recnum+1)
      if (VSseek(vdata_id_mec_f1d, recnum_rd)==FAIL) {
          print_mec_f1d_error("read_mec_f1d -> VSseek unsuccessful");
          retval = -1;
    }
  last_recnum = recnum_rd;

  if(VSread(vdata_id_mec_f1d, (uint8 *)odata, 1, FULL_INTERLACE) ==FAIL) {
    print_mec_f1d_error("read_mec_f1d -> VSread: Couldn't read data.");
    retval = -1;
  }
  unpack_mec_f1d(odata, MEC_f1d_struc);
  free(odata);
  return(retval);
}

/*----   close read function    ----*/

void close_rd_mec_f1d()
{
  VSdetach(vdata_id_mec_f1d);
}

/*----  Read V group description, function    ----*/
void rd_Vgrp_desc_mec_f1d(int32 hdf_fp, int32 an_id)
{
  int32 ann_id_r;
  int32 num_ann;
  int32 *ann_list;
  int32 vgrp_ref_r;

void print_mec_f1d_error();

  /*      Get the Vgroup reference     */
  if ((vgrp_ref_r = Vfind(hdf_fp, "VG_MEC_f1d" )) ==FAIL)
    print_mec_f1d_error("rd_Vgrp_mec_f1d -> Vfind: Couldn't get Vgrp reference.");

  if ((num_ann = ANnumann(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r)) ==FAIL)
    print_mec_f1d_error("rd_Vgrp_mec_f1d -> ANnumann: Couldn't get number of annotations.");

printf("1numann= %d \n", num_ann);
    ann_list = HDmalloc(num_ann * sizeof(int32));
printf("1ann_list= %d \n", ann_list);
  if ((num_ann = ANannlist(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r, ann_list)) ==FAIL)
    print_mec_f1d_error("rd_Vgrp_mec_f1d -> ANannlist: Couldn't");

printf("2numann= %d \n", num_ann);
printf("2ann_list= %d \n", ann_list);
  if ((ann_id_r = ANselect(an_id, (num_ann-1), AN_DATA_DESC)) ==FAIL)
    print_mec_f1d_error("rd_Vgrp_mec_f1d -> ANselect: Couldn't");

  if (ANreadann(ann_id_r, Vgrp_descrp_MEC_f1d, HDstrlen(Vgrp_descrp_MEC_f1d)) ==FAIL)
    print_mec_f1d_error("rd_Vgrp_mec_f1d -> ANreadann: Couldn't");

  printf("AN: %s\n", Vgrp_descrp_MEC_f1d);
  ANendaccess(ann_id_r);
  ANend(an_id);
}

/*----   error function    ----*/

void print_mec_f1d_error(int8 *mess)
{
  fprintf(stderr,"\nERROR in  mec_f1d.c -> %s\n", mess);
  HEprint(stderr, 0);
}

/*----   pack function    ----*/

void pack_mec_f1d(uint8 *data, struct MEC_f1d *MEC_f1d_ptr)
{
int32 ptr=0;

   memcpy(data+ptr, &MEC_f1d_ptr->sclk_seconds, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_f1d_ptr->sclk_subseconds, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &MEC_f1d_ptr->f1d_ion_distr[0], ((4)*(MEC_F1D_ELEMENTS)) );
   ptr+= ((4)*(MEC_F1D_ELEMENTS));
}

/*----   unpack function    ----*/

void unpack_mec_f1d(uint8 *data, struct MEC_f1d *MEC_f1d_ptr)
{
int32 ptr=0;

   memcpy(&MEC_f1d_ptr->sclk_seconds, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_f1d_ptr->sclk_subseconds, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&MEC_f1d_ptr->f1d_ion_distr[0], data+ptr,  ((4)*(MEC_F1D_ELEMENTS)) );
   ptr+= ((4)*(MEC_F1D_ELEMENTS));
}
int32 get_vgrp_id_mec_f1d() {return(vgrp_id_mec_f1d);}

/*----   V group description function    ----*/

int32 wr_Vgrp_desc_mec_f1d(char *wr_strval)
{
  strcpy(wr_strval, "The file 'mec_f1d.h' is shown below, it was used to create the data in the Vgroup named 'VG_MEC_f1d'.\n\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"/*\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   GNS EDR Structure definitions -- WIND F1D Data \n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   BVS/NAIF, August 17, 2000\n");
  strcat(wr_strval,"    \n");
  strcat(wr_strval,"*/\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"#include \"hdfi.h\"\n");
  strcat(wr_strval,"#include \"gns_edr_const.h\"\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"/*\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"   MEC/WIND F1D Ion Distribution Data Structure -- APID # 26\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"      sclk_seconds      -- S/C time at start of data cycle, seconds\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      sclk_subseconds   -- S/C time at start of data cycle, fractions \n");
  strcat(wr_strval,"                           (1/65536th) of SCLK second\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      f1d_ion_distr[40] -- WIND F1D ion distribution array\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"*/\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"struct MEC_f1d {\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"   uint32   sclk_seconds;\n");
  strcat(wr_strval,"   uint16   sclk_subseconds;\n");
  strcat(wr_strval,"   float32  f1d_ion_distr[MEC_F1D_ELEMENTS];\n");
  strcat(wr_strval,"                                       \n");
  strcat(wr_strval,"};\n");
  strcat(wr_strval,"\n");
  return(0);
}
