
/*
  
   GNS EDR Structure definitions -- WIND F1D Data 
  
   BVS/NAIF, August 17, 2000
    
*/

#include "hdfi.h"
#include "gns_edr_const.h"

/*
   
   MEC/WIND F1D Ion Distribution Data Structure -- APID # 26
   
      sclk_seconds      -- S/C time at start of data cycle, seconds
      
      sclk_subseconds   -- S/C time at start of data cycle, fractions 
                           (1/65536th) of SCLK second
      
      f1d_ion_distr[40] -- WIND F1D ion distribution array
   
*/

struct MEC_f1d {

   uint32   sclk_seconds;
   uint16   sclk_subseconds;
   float32  f1d_ion_distr[MEC_F1D_ELEMENTS];
                                       
};

