/* The RCS version of hdfgen.pl used to create this file is: */
/* $Id: hdfgen.pl,v 1.5 2000/02/17 18:32:30 esm Exp  */

  /* An RCS (Revision Control System) header */

  /* for the include file is not on the first line. */

#include "mec_hk.h"
#include "df.h"

int32 vgrp_id_mec_hk;
static int32 vdata_id_mec_hk;

  /* 8714 is the size of mec_hk.h + 1 added line */
char Vgrp_descrp_MEC_Housekeeping[8714];

/****----  init create function  ----****/

int32 init_cr_mec_hk(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{
  int32 retval=0;
  int32 vgrp_ref_w;
  int32 ann_id_w;
  int32 wr_Vgrp_desc_mec_hk();

  void print_mec_hk_error();

  /*         Setup a Vgroup         */
  if ((vgrp_id_mec_hk = Vattach(hdf_fp, -1, "w"))==FAIL) {
    print_mec_hk_error("init_cr_mec_hk -> Vattach: Couldn't create Vgroup");
    retval = -1;
  }
  Vsetname(vgrp_id_mec_hk, "VG_MEC_Housekeeping"); 
  Vsetclass(vgrp_id_mec_hk, "VG_MEC_HK");


  /*      Get the Vgroup reference     */
  if ((vgrp_ref_w = Vfind(hdf_fp, "VG_MEC_Housekeeping" )) ==FAIL) {
    print_mec_hk_error("init_cr_mec_hk -> Vfind: Couldn't get Vgrp reference");
    retval = -1;
  }
  /*      Add a description to the Vgroup      */
  wr_Vgrp_desc_mec_hk(Vgrp_descrp_MEC_Housekeeping);

  if ((ann_id_w = ANcreate(an_id, DFTAG_VG, vgrp_ref_w, AN_DATA_DESC)) ==FAIL) {
    print_mec_hk_error("init_cr_mec_hk -> ANcreate: Can't create Vgrp description");
    retval = -1;
  }
  if ((ANwriteann(ann_id_w, Vgrp_descrp_MEC_Housekeeping, sizeof(Vgrp_descrp_MEC_Housekeeping))) ==FAIL) {
    print_mec_hk_error("init_cr_mec_hk -> ANwriteann: Can't write Vgrp description");
    retval = -1;
  }
  ANendaccess(ann_id_w);

  /*        Setup a Vdata        */
  if ((vdata_id_mec_hk = VSattach(hdf_fp, -1, "w")) ==FAIL) {
    print_mec_hk_error("init_cr_mec_hk -> VSattach: Couldn't attach to Vdata");
    retval = -1;
  }
  VSsetname(vdata_id_mec_hk, "MEC_Housekeeping");
  VSsetclass(vdata_id_mec_hk, classname);

  /*       Insert the Vdata into the Vgroup       */
  if ((Vinsert(vgrp_id_mec_hk, vdata_id_mec_hk)) ==FAIL) {
    print_mec_hk_error("init_cr_mec_hk -> Vinsert: Couldn't insert Vdata into Vgroup");
    retval = -1;
  }

  /*    Define the fields in the Vdata    */
  if (VSfdefine(vdata_id_mec_hk, "sclk_seconds", DFNT_UINT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define sclk_seconds");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "sclk_subseconds", DFNT_UINT16, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define sclk_subseconds");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "WIND_MEC_FLAGS", DFNT_UINT16, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define WIND_MEC_FLAGS");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "gim_peak_azim", DFNT_UINT8, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define gim_peak_azim");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "gim_peak_CEM", DFNT_UINT8, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define gim_peak_CEM");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "bde_disqual_cnt", DFNT_UINT8, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define bde_disqual_cnt");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "bde_azim_cnt", DFNT_UINT8, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define bde_azim_cnt");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "bde_polar_cnt", DFNT_UINT8, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define bde_polar_cnt");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "regime", DFNT_UINT8, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define regime");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "WIND_REGIME_FLAGS", DFNT_UINT16, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define WIND_REGIME_FLAGS");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "gim_deadtime", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define gim_deadtime");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "gim_bg_level", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define gim_bg_level");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "gem_deadtime", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define gem_deadtime");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "gem_bg_level", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define gem_bg_level");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "proton_density_curr", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define proton_density_curr");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "proton_speed_curr", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define proton_speed_curr");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "proton_temp_curr", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define proton_temp_curr");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "proton_temp_exp_ratio_curr", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define proton_temp_exp_ratio_curr");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "alpha_ratio_curr", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define alpha_ratio_curr");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "proton_density_av", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define proton_density_av");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "proton_speed_av", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define proton_speed_av");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "proton_temp_av", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define proton_temp_av");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "proton_temp_exp_ratio_av", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define proton_temp_exp_ratio_av");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "alpha_ratio_av", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define alpha_ratio_av");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "BDE_av", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define BDE_av");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "TO_CME", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define TO_CME");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "V1_ave", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define V1_ave");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "V2_ave", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define V2_ave");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "N1_ave", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define N1_ave");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "N2_ave", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define N2_ave");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "T1_ave", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define T1_ave");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "T2_ave", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define T2_ave");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "TIME_OF_SHOCK", DFNT_UINT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define TIME_OF_SHOCK");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "TIME_OF_CME", DFNT_UINT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define TIME_OF_CME");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "F1D_PROT_PEAK", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define F1D_PROT_PEAK");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "F1D_MIN", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define F1D_MIN");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "F1D_HE_PEAK", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define F1D_HE_PEAK");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "PROT_PEAK_LEVEL", DFNT_UINT16, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define PROT_PEAK_LEVEL");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "PROT_ALPHA_MIN_LEVEL", DFNT_UINT16, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define PROT_ALPHA_MIN_LEVEL");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "ALPHA_PEAK_LEVEL", DFNT_UINT16, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define ALPHA_PEAK_LEVEL");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "HIST_ENTRIES", DFNT_UINT16, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define HIST_ENTRIES");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "HIST_MAX_GAP", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define HIST_MAX_GAP");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "COUNT_PEAK", DFNT_FLOAT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define COUNT_PEAK");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mec_hk, "extra_data", DFNT_UINT32, (1) )) {
    print_mec_hk_error("init_cr_mec_hk -> VSfdefine: Couldn't define extra_data");
    retval = -1;
  }

  if (VSsetfields(vdata_id_mec_hk,"sclk_seconds, sclk_subseconds, WIND_MEC_FLAGS, gim_peak_azim, gim_peak_CEM, bde_disqual_cnt, bde_azim_cnt, bde_polar_cnt, regime, WIND_REGIME_FLAGS, gim_deadtime, gim_bg_level, gem_deadtime, gem_bg_level, proton_density_curr, proton_speed_curr, proton_temp_curr, proton_temp_exp_ratio_curr, alpha_ratio_curr, proton_density_av, proton_speed_av, proton_temp_av, proton_temp_exp_ratio_av, alpha_ratio_av, BDE_av, TO_CME, V1_ave, V2_ave, N1_ave, N2_ave, T1_ave, T2_ave, TIME_OF_SHOCK, TIME_OF_CME, F1D_PROT_PEAK, F1D_MIN, F1D_HE_PEAK, PROT_PEAK_LEVEL, PROT_ALPHA_MIN_LEVEL, ALPHA_PEAK_LEVEL, HIST_ENTRIES, HIST_MAX_GAP, COUNT_PEAK, extra_data")){
    print_mec_hk_error("init_cr_mec_hk -> VSsetfields: Couldn't set fields");
    retval = -1;
  }

  return(retval);
}

/* Included for backwards compatibility */

int32 init_wr_mec_hk(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{ return( init_cr_mec_hk(hdf_fp, sd_id, an_id, classname) ); }

/******---- write function ----******/

int32 write_mec_hk(struct MEC_Housekeeping MEC_Housekeeping_struc, int32 recnum)
{
  int32 retval = 0;
  uint8 *odata;

void print_mec_hk_error();
void pack_mec_hk();

  odata = (uint8 *) malloc(sizeof(struct MEC_Housekeeping));
  pack_mec_hk(odata, &MEC_Housekeeping_struc);

  if(recnum!=-1) {
	if(VSseek(vdata_id_mec_hk, recnum)==-1) {
		print_mec_hk_error("write_mec_hk -> VSseek: error.");
		retval = -1;
	}
  }
  if(VSwrite(vdata_id_mec_hk, (uint8 *)odata, 1, FULL_INTERLACE) == -1)
    print_mec_hk_error("write_mec_hk -> VSwrite: Couldn't write data.");

  memset(&MEC_Housekeeping_struc, 0, sizeof(struct MEC_Housekeeping));
  free(odata);
  return(retval);
}

/*----   close write function    ----*/

void close_wr_mec_hk()
{
  VSdetach(vdata_id_mec_hk);
  Vdetach(vgrp_id_mec_hk);
}

/*----     init access function    ----*/

int32 init_acc_mec_hk(int32 hdf_fp, int32 sd_id, char *access_mode)
{
  int32 vdata_ref;
  int32 num_rec;

  void print_mec_hk_error();


  if ((vdata_ref = VSfind(hdf_fp, "MEC_Housekeeping")) <= 0 ) {
    print_mec_hk_error("init_acc_mec_hk -> VSfind: Found no vdata of specified type.");
    return(0);
  }
  if ((vdata_id_mec_hk = VSattach(hdf_fp, vdata_ref, access_mode)) ==FAIL) {
    print_mec_hk_error("init_acc_mec_hk -> VSattach: Couldn't attach to hdf file.");
    return(-1);
  }

  VSinquire(vdata_id_mec_hk, &num_rec, NULL, NULL, NULL, NULL);
  if (num_rec == 0) { return(0); }


  if (VSsetfields(vdata_id_mec_hk,"sclk_seconds, sclk_subseconds, WIND_MEC_FLAGS, gim_peak_azim, gim_peak_CEM, bde_disqual_cnt, bde_azim_cnt, bde_polar_cnt, regime, WIND_REGIME_FLAGS, gim_deadtime, gim_bg_level, gem_deadtime, gem_bg_level, proton_density_curr, proton_speed_curr, proton_temp_curr, proton_temp_exp_ratio_curr, alpha_ratio_curr, proton_density_av, proton_speed_av, proton_temp_av, proton_temp_exp_ratio_av, alpha_ratio_av, BDE_av, TO_CME, V1_ave, V2_ave, N1_ave, N2_ave, T1_ave, T2_ave, TIME_OF_SHOCK, TIME_OF_CME, F1D_PROT_PEAK, F1D_MIN, F1D_HE_PEAK, PROT_PEAK_LEVEL, PROT_ALPHA_MIN_LEVEL, ALPHA_PEAK_LEVEL, HIST_ENTRIES, HIST_MAX_GAP, COUNT_PEAK, extra_data")) {
      print_mec_hk_error("init_acc_mec_hk -> VSsetfields: Unable to set fields.");

      return(-1);
  }
  return(num_rec);
}

/* Included for backwards compatability */

int32 init_rd_mec_hk(int32 hdf_fp, int32 sd_id, char *access_mode)
{ return ( init_acc_mec_hk(hdf_fp, sd_id, access_mode) ); }

/******---- read function ----******/

int32 read_mec_hk(struct MEC_Housekeeping *MEC_Housekeeping_struc, int32 recnum_rd)
{
static int32 last_recnum = -1;
int32 maxrec;
int32 retval = 0;
uint8 *odata;

void print_mec_hk_error();
void unpack_mec_hk();

  if(recnum_rd==-1) recnum_rd=last_recnum+1;

  odata = (uint8 *) malloc(sizeof(struct MEC_Housekeeping));
  VSinquire(vdata_id_mec_hk, &maxrec, NULL, NULL, NULL, NULL);
  if (recnum_rd >= maxrec) return(-1);
  if (recnum_rd != last_recnum+1)
      if (VSseek(vdata_id_mec_hk, recnum_rd)==FAIL) {
          print_mec_hk_error("read_mec_hk -> VSseek unsuccessful");
          retval = -1;
    }
  last_recnum = recnum_rd;

  if(VSread(vdata_id_mec_hk, (uint8 *)odata, 1, FULL_INTERLACE) ==FAIL) {
    print_mec_hk_error("read_mec_hk -> VSread: Couldn't read data.");
    retval = -1;
  }
  unpack_mec_hk(odata, MEC_Housekeeping_struc);
  free(odata);
  return(retval);
}

/*----   close read function    ----*/

void close_rd_mec_hk()
{
  VSdetach(vdata_id_mec_hk);
}

/*----  Read V group description, function    ----*/
void rd_Vgrp_desc_mec_hk(int32 hdf_fp, int32 an_id)
{
  int32 ann_id_r;
  int32 num_ann;
  int32 *ann_list;
  int32 vgrp_ref_r;

void print_mec_hk_error();

  /*      Get the Vgroup reference     */
  if ((vgrp_ref_r = Vfind(hdf_fp, "VG_MEC_Housekeeping" )) ==FAIL)
    print_mec_hk_error("rd_Vgrp_mec_hk -> Vfind: Couldn't get Vgrp reference.");

  if ((num_ann = ANnumann(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r)) ==FAIL)
    print_mec_hk_error("rd_Vgrp_mec_hk -> ANnumann: Couldn't get number of annotations.");

printf("1numann= %d \n", num_ann);
    ann_list = HDmalloc(num_ann * sizeof(int32));
printf("1ann_list= %d \n", ann_list);
  if ((num_ann = ANannlist(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r, ann_list)) ==FAIL)
    print_mec_hk_error("rd_Vgrp_mec_hk -> ANannlist: Couldn't");

printf("2numann= %d \n", num_ann);
printf("2ann_list= %d \n", ann_list);
  if ((ann_id_r = ANselect(an_id, (num_ann-1), AN_DATA_DESC)) ==FAIL)
    print_mec_hk_error("rd_Vgrp_mec_hk -> ANselect: Couldn't");

  if (ANreadann(ann_id_r, Vgrp_descrp_MEC_Housekeeping, HDstrlen(Vgrp_descrp_MEC_Housekeeping)) ==FAIL)
    print_mec_hk_error("rd_Vgrp_mec_hk -> ANreadann: Couldn't");

  printf("AN: %s\n", Vgrp_descrp_MEC_Housekeeping);
  ANendaccess(ann_id_r);
  ANend(an_id);
}

/*----   error function    ----*/

void print_mec_hk_error(int8 *mess)
{
  fprintf(stderr,"\nERROR in  mec_hk.c -> %s\n", mess);
  HEprint(stderr, 0);
}

/*----   pack function    ----*/

void pack_mec_hk(uint8 *data, struct MEC_Housekeeping *MEC_Housekeeping_ptr)
{
int32 ptr=0;

   memcpy(data+ptr, &MEC_Housekeeping_ptr->sclk_seconds, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->sclk_subseconds, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->WIND_MEC_FLAGS, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->gim_peak_azim, ((1)*(1)) );
   ptr+= ((1)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->gim_peak_CEM, ((1)*(1)) );
   ptr+= ((1)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->bde_disqual_cnt, ((1)*(1)) );
   ptr+= ((1)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->bde_azim_cnt, ((1)*(1)) );
   ptr+= ((1)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->bde_polar_cnt, ((1)*(1)) );
   ptr+= ((1)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->regime, ((1)*(1)) );
   ptr+= ((1)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->WIND_REGIME_FLAGS, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->gim_deadtime, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->gim_bg_level, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->gem_deadtime, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->gem_bg_level, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->proton_density_curr, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->proton_speed_curr, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->proton_temp_curr, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->proton_temp_exp_ratio_curr, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->alpha_ratio_curr, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->proton_density_av, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->proton_speed_av, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->proton_temp_av, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->proton_temp_exp_ratio_av, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->alpha_ratio_av, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->BDE_av, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->TO_CME, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->V1_ave, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->V2_ave, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->N1_ave, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->N2_ave, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->T1_ave, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->T2_ave, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->TIME_OF_SHOCK, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->TIME_OF_CME, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->F1D_PROT_PEAK, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->F1D_MIN, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->F1D_HE_PEAK, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->PROT_PEAK_LEVEL, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->PROT_ALPHA_MIN_LEVEL, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->ALPHA_PEAK_LEVEL, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->HIST_ENTRIES, ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->HIST_MAX_GAP, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->COUNT_PEAK, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MEC_Housekeeping_ptr->extra_data, ((4)*(1)) );
   ptr+= ((4)*(1));
}

/*----   unpack function    ----*/

void unpack_mec_hk(uint8 *data, struct MEC_Housekeeping *MEC_Housekeeping_ptr)
{
int32 ptr=0;

   memcpy(&MEC_Housekeeping_ptr->sclk_seconds, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->sclk_subseconds, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&MEC_Housekeeping_ptr->WIND_MEC_FLAGS, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&MEC_Housekeeping_ptr->gim_peak_azim, data+ptr,  ((1)*(1)) );
   ptr+= ((1)*(1));
   memcpy(&MEC_Housekeeping_ptr->gim_peak_CEM, data+ptr,  ((1)*(1)) );
   ptr+= ((1)*(1));
   memcpy(&MEC_Housekeeping_ptr->bde_disqual_cnt, data+ptr,  ((1)*(1)) );
   ptr+= ((1)*(1));
   memcpy(&MEC_Housekeeping_ptr->bde_azim_cnt, data+ptr,  ((1)*(1)) );
   ptr+= ((1)*(1));
   memcpy(&MEC_Housekeeping_ptr->bde_polar_cnt, data+ptr,  ((1)*(1)) );
   ptr+= ((1)*(1));
   memcpy(&MEC_Housekeeping_ptr->regime, data+ptr,  ((1)*(1)) );
   ptr+= ((1)*(1));
   memcpy(&MEC_Housekeeping_ptr->WIND_REGIME_FLAGS, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&MEC_Housekeeping_ptr->gim_deadtime, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->gim_bg_level, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->gem_deadtime, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->gem_bg_level, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->proton_density_curr, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->proton_speed_curr, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->proton_temp_curr, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->proton_temp_exp_ratio_curr, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->alpha_ratio_curr, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->proton_density_av, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->proton_speed_av, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->proton_temp_av, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->proton_temp_exp_ratio_av, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->alpha_ratio_av, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->BDE_av, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->TO_CME, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->V1_ave, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->V2_ave, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->N1_ave, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->N2_ave, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->T1_ave, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->T2_ave, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->TIME_OF_SHOCK, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->TIME_OF_CME, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->F1D_PROT_PEAK, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->F1D_MIN, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->F1D_HE_PEAK, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->PROT_PEAK_LEVEL, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&MEC_Housekeeping_ptr->PROT_ALPHA_MIN_LEVEL, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&MEC_Housekeeping_ptr->ALPHA_PEAK_LEVEL, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&MEC_Housekeeping_ptr->HIST_ENTRIES, data+ptr,  ((2)*(1)) );
   ptr+= ((2)*(1));
   memcpy(&MEC_Housekeeping_ptr->HIST_MAX_GAP, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->COUNT_PEAK, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MEC_Housekeeping_ptr->extra_data, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
}
int32 get_vgrp_id_mec_hk() {return(vgrp_id_mec_hk);}

/*----   V group description function    ----*/

int32 wr_Vgrp_desc_mec_hk(char *wr_strval)
{
  strcpy(wr_strval, "The file 'mec_hk.h' is shown below, it was used to create the data in the Vgroup named 'VG_MEC_Housekeeping'.\n\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"/*\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   GNS EDR Structure definitions -- MEC/WIND Housekeeping Data \n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   BVS/NAIF, April 12, 2001\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"      Added one more unit32 field \"extra_data\" at the end of the \n");
  strcat(wr_strval,"      structure to accommodate MEC/WIND APID change (LMA class \n");
  strcat(wr_strval,"      I/II change ref No. XH0304 from March 2001)\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   BVS/NAIF, August 16, 2000\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"      Changed COUNT_PEAK type from uint32 to float32 to correspond \n");
  strcat(wr_strval,"      to the APID structure definition (GenMap.xls spreadsheet by\n");
  strcat(wr_strval,"      Karl Lauffer, LMA.)\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   BVS/NAIF, June 7, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"      Changed sclk_subseconds type from uint8 to uint16 to preserve \n");
  strcat(wr_strval,"      full resolution of the fractional part of SCLK. Updated \n");
  strcat(wr_strval,"      description to reflect this change. Added WIND_MEC_FLAGS and \n");
  strcat(wr_strval,"      WIND_REGIME_FLAGS bit breakdown description. Changed COUNT_PEAK\n");
  strcat(wr_strval,"      type from uint16 to uint32 to comply with Karl Lauffers table\n");
  strcat(wr_strval,"      (6/19/00)\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   BVS/NAIF, May 7, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"      Changed to correspond to the \"better-defined\" packet structure\n");
  strcat(wr_strval,"      provided by John Steinberg on April 27, 2000)\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   BVS/NAIF, March 2, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"      Reformatted comments; included gnd_edr_const.h.\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"   BVS/NAIF, February 17, 2000\n");
  strcat(wr_strval,"  \n");
  strcat(wr_strval,"*/\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"#include \"hdfi.h\"\n");
  strcat(wr_strval,"#include \"gns_edr_const.h\"\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"/*\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"   MEC/WIND Housekeeping data structure -- APID # 24\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"      sclk_seconds      -- S/C time at start of data cycle, seconds\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      sclk_subseconds   -- S/C time at start of data cycle, fractions \n");
  strcat(wr_strval,"                           (1/65536th) of SCLK second\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      WIND_MEC_FLAGS    -- MEC status word (MSB order):\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"                              bit 10 = DATA_OK\n");
  strcat(wr_strval,"                              bit 9  = gim_ok\n");
  strcat(wr_strval,"                              bit 8  = gem_ok\n");
  strcat(wr_strval,"                              bit 7  = mec_ok\n");
  strcat(wr_strval,"                              bit 6  = gim_dt_ok\n");
  strcat(wr_strval,"                              bit 5  = peak_find_ok\n");
  strcat(wr_strval,"                              bit 4  = alpha_avail\n");
  strcat(wr_strval,"                              bit 3  = bde_avail\n");
  strcat(wr_strval,"                              bit 2  = bde_detected\n");
  strcat(wr_strval,"                              bit 1  = gem_dt_ok\n");
  strcat(wr_strval,"                              bit 0  = POLAR_EARTH\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      gim_peak_azim     -- Index on GIM az angle, 0-39\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      gim_peak_CEM      -- Index on GIM CEM, 0-7\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      bde_disqual_cnt   -- Number double-peaks in az disqualified \n");
  strcat(wr_strval,"                           because direction aligned with Earth\n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      bde_azim_cnt      -- Number double-peaks in az found and Not \n");
  strcat(wr_strval,"                           disqualified because direction aligned    \n");
  strcat(wr_strval,"                           with Earth\n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      bde_polar_cnt     -- Number of times clear valleys found in the \n");
  strcat(wr_strval,"                           polar BDE check (CEM 0 and 6 peaks)\n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      regime            -- Final result of the regime code - state \n");
  strcat(wr_strval,"                           that array is commanded to - E, H, or L\n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      WIND_REGIME_FLAGS -- REGIME status word (MSB order):\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"                              bit 9 = proton_hist_despike\n");
  strcat(wr_strval,"                              bit 8 = alpha_hist_despike\n");
  strcat(wr_strval,"                              bit 7 = conc_to_standby\n");
  strcat(wr_strval,"                              bit 6 = gim_search_req\n");
  strcat(wr_strval,"                              bit 5 = max_gap_exceeded\n");
  strcat(wr_strval,"                              bit 4 = min_count_missed\n");
  strcat(wr_strval,"                              bit 3 = bulk_selected\n");
  strcat(wr_strval,"                              bit 2 = shock_detected\n");
  strcat(wr_strval,"                              bit 1 = alpha weight\n");
  strcat(wr_strval,"                              bit 0 = BDE weight\n");
  strcat(wr_strval,"                              \n");
  strcat(wr_strval,"      gim_deadtime      -- GIM deadtime - the configured parameter, \n");
  strcat(wr_strval,"                           (UNITS?)\n");
  strcat(wr_strval,"                            \n");
  strcat(wr_strval,"      gim_bg_level      -- GIM background level from on-board \n");
  strcat(wr_strval,"                           calculation, decimal counts\n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      gem_deadtime      -- GEM deadtime - the configured parameter,\n");
  strcat(wr_strval,"                           (UNITS?)\n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      gem_bg_level      -- GEM background level from on-board \n");
  strcat(wr_strval,"                           calculation, decimal counts\n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      proton_density_curr  \n");
  strcat(wr_strval,"                        -- proton_density in cm-3\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      proton_speed_curr -- proton_speed in cm/s \n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      proton_temp_curr  -- proton_temp in K\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      proton_temp_exp_ratio_curr \n");
  strcat(wr_strval,"                        -- proton_temp_exp_ratio, unitless ratio\n");
  strcat(wr_strval,"                                    \n");
  strcat(wr_strval,"      alpha_ratio_curr  -- alpha_ratio, unitless ratio\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      proton_density_av -- proton_density average over the history,\n");
  strcat(wr_strval,"                           cm-3  \n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      proton_speed_av   -- proton_speed averaged over the history,\n");
  strcat(wr_strval,"                           cm/s\n");
  strcat(wr_strval,"                            \n");
  strcat(wr_strval,"      proton_temp_av    -- proton_temp_av averaged over the history,\n");
  strcat(wr_strval,"                           units K\n");
  strcat(wr_strval,"                            \n");
  strcat(wr_strval,"      proton_temp_exp_ratio_av   \n");
  strcat(wr_strval,"                        -- proton_temp_exp_ratio_av averaged over the \n");
  strcat(wr_strval,"                           history, unitless ratio\n");
  strcat(wr_strval,"                                    \n");
  strcat(wr_strval,"      alpha_ratio_av    -- alpha_ratio_av averaged over the history,\n");
  strcat(wr_strval,"                           unitless ratio\n");
  strcat(wr_strval,"                            \n");
  strcat(wr_strval,"      BDE_av            -- BDE average over the history, between 0.0-1.0\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      TO_CME            -- regime algorithm parameter, between 0.0 and\n");
  strcat(wr_strval,"                           1.0\n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      V1_ave            -- speed ave over 1st half of history, cm/s\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      V2_ave            -- speed ave over 2nd half of history, cm/s\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      N1_ave            -- prot density ave over 1st half of history,\n");
  strcat(wr_strval,"                           cm-3\n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      N2_ave            -- prot density ave over end half of history,\n");
  strcat(wr_strval,"                           cm-3\n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      T1_ave            -- temp ave over 1st half of history, K\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      T2_ave            -- temp ave over 2nd half of history, K\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      TIME_OF_SHOCK     -- Time of shock, SCLK seconds\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      TIME_OF_CME       -- time of CME, SCLK seconds\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      F1D_PROT_PEAK     -- 1D Dist value at proton peak \n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      F1D_MIN           -- ID Dist value at Min between Proton \n");
  strcat(wr_strval,"                           and Alpha Peaks\n");
  strcat(wr_strval,"                           \n");
  strcat(wr_strval,"      F1D_HE_PEAK       -- 1D Dist value at the alpha peak\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      PROT_PEAK_LEVEL   -- energy step (0-39) where peak found\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      PROT_ALPHA_MIN_LEVEL \n");
  strcat(wr_strval,"                        -- energy step (0-39) where min found\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      ALPHA_PEAK_LEVEL  -- energy step (0-39) where alpha peak found\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      HIST_ENTRIES      -- Number of valid history entries\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      HIST_MAX_GAP      -- Longest contiguous history gap, (UNITS?)\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"      COUNT_PEAK        -- uncompressed count associated with the peak\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"      extra_data        -- Extra Wind data and room for expansion\n");
  strcat(wr_strval,"                           (MSB order):\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"                              bit 31    = aband_data_cycle_bool\n");
  strcat(wr_strval,"                              bit 29-30 = aband_data_cycle_spin(*)\n");
  strcat(wr_strval,"                              bit 0-28  = spare\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"                           (*) aband_data_cycle_spin contents are \n");
  strcat(wr_strval,"                              meaningful only when the \n");
  strcat(wr_strval,"                              aband_data_cycle_bool flag is TRUE.\n");
  strcat(wr_strval,"   \n");
  strcat(wr_strval,"*/\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"struct MEC_Housekeeping {\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"   uint32   sclk_seconds;\n");
  strcat(wr_strval,"   uint16   sclk_subseconds;\n");
  strcat(wr_strval,"   uint16   WIND_MEC_FLAGS;\n");
  strcat(wr_strval,"   uint8    gim_peak_azim;\n");
  strcat(wr_strval,"   uint8    gim_peak_CEM;\n");
  strcat(wr_strval,"   uint8    bde_disqual_cnt;\n");
  strcat(wr_strval,"   uint8    bde_azim_cnt;\n");
  strcat(wr_strval,"   uint8    bde_polar_cnt;\n");
  strcat(wr_strval,"   uint8    regime;\n");
  strcat(wr_strval,"   uint16   WIND_REGIME_FLAGS;\n");
  strcat(wr_strval,"   float32  gim_deadtime;\n");
  strcat(wr_strval,"   float32  gim_bg_level;\n");
  strcat(wr_strval,"   float32  gem_deadtime;\n");
  strcat(wr_strval,"   float32  gem_bg_level;\n");
  strcat(wr_strval,"   float32  proton_density_curr;\n");
  strcat(wr_strval,"   float32  proton_speed_curr;\n");
  strcat(wr_strval,"   float32  proton_temp_curr;\n");
  strcat(wr_strval,"   float32  proton_temp_exp_ratio_curr;\n");
  strcat(wr_strval,"   float32  alpha_ratio_curr;\n");
  strcat(wr_strval,"   float32  proton_density_av;\n");
  strcat(wr_strval,"   float32  proton_speed_av;\n");
  strcat(wr_strval,"   float32  proton_temp_av;\n");
  strcat(wr_strval,"   float32  proton_temp_exp_ratio_av;\n");
  strcat(wr_strval,"   float32  alpha_ratio_av;\n");
  strcat(wr_strval,"   float32  BDE_av;\n");
  strcat(wr_strval,"   float32  TO_CME;\n");
  strcat(wr_strval,"   float32  V1_ave;\n");
  strcat(wr_strval,"   float32  V2_ave;\n");
  strcat(wr_strval,"   float32  N1_ave;\n");
  strcat(wr_strval,"   float32  N2_ave;\n");
  strcat(wr_strval,"   float32  T1_ave;\n");
  strcat(wr_strval,"   float32  T2_ave;\n");
  strcat(wr_strval,"   uint32   TIME_OF_SHOCK;\n");
  strcat(wr_strval,"   uint32   TIME_OF_CME;\n");
  strcat(wr_strval,"   float32  F1D_PROT_PEAK;\n");
  strcat(wr_strval,"   float32  F1D_MIN;\n");
  strcat(wr_strval,"   float32  F1D_HE_PEAK;\n");
  strcat(wr_strval,"   uint16   PROT_PEAK_LEVEL;\n");
  strcat(wr_strval,"   uint16   PROT_ALPHA_MIN_LEVEL;\n");
  strcat(wr_strval,"   uint16   ALPHA_PEAK_LEVEL;\n");
  strcat(wr_strval,"   uint16   HIST_ENTRIES;\n");
  strcat(wr_strval,"   float32  HIST_MAX_GAP;\n");
  strcat(wr_strval,"   float32  COUNT_PEAK;\n");
  strcat(wr_strval,"   uint32   extra_data;\n");
  strcat(wr_strval,"                                       \n");
  strcat(wr_strval,"};\n");
  strcat(wr_strval,"\n");
  return(0);
}
